/* valamethod.c generated by valac, the Vala compiler
 * generated from valamethod.vala, do not modify */

/* valamethod.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 * Copyright (C) 2006-2008  Raffaele Sandrini
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 *	Raffaele Sandrini <raffaele@sandrini.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "vala.h"
#include <valagee.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_iterator_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterator_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _vala_code_context_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_context_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ValaMethodPrivate {
	ValaList* type_parameters;
	ValaMemberBinding _binding;
	gboolean _is_abstract;
	gboolean _is_virtual;
	gboolean _overrides;
	gboolean _is_inline;
	gboolean _entry_point;
	ValaParameter* _this_parameter;
	ValaSignal* _signal_reference;
	gboolean _closure;
	gboolean _coroutine;
	gboolean _is_async_callback;
	ValaList* parameters;
	ValaList* preconditions;
	ValaList* postconditions;
	ValaDataType* _return_type;
	ValaMethod* _base_method;
	ValaMethod* _base_interface_method;
	ValaDataType* _base_interface_type;
	gboolean base_methods_valid;
	ValaMethod* callback_method;
	ValaMethod* end_method;
	ValaList* captured_variables;
};


static gpointer vala_method_parent_class = NULL;
static ValaList* vala_method__empty_expression_list;
static ValaList* vala_method__empty_expression_list = NULL;
static ValaList* vala_method__empty_type_parameter_list;
static ValaList* vala_method__empty_type_parameter_list = NULL;
static ValaCallableIface * vala_method_vala_callable_parent_iface = NULL;

#define VALA_METHOD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_METHOD, ValaMethodPrivate))
static void vala_method_real_add_parameter (ValaCallable* base,
                                     ValaParameter* param);
static ValaList* vala_method_real_get_parameters (ValaCallable* base);
static void vala_method_real_accept (ValaCodeNode* base,
                              ValaCodeVisitor* visitor);
static void vala_method_real_accept_children (ValaCodeNode* base,
                                       ValaCodeVisitor* visitor);
static void vala_method_real_replace_type (ValaCodeNode* base,
                                    ValaDataType* old_type,
                                    ValaDataType* new_type);
static void vala_method_find_base_methods (ValaMethod* self);
static void vala_method_find_base_interface_method (ValaMethod* self,
                                             ValaClass* cl);
static void vala_method_find_base_class_method (ValaMethod* self,
                                         ValaClass* cl);
static gboolean vala_method_real_check (ValaCodeNode* base,
                                 ValaCodeContext* context);
static gboolean vala_method_is_possible_entry_point (ValaMethod* self,
                                              ValaCodeContext* context);
static void vala_method_set_entry_point (ValaMethod* self,
                                  gboolean value);
static void vala_method_real_get_defined_variables (ValaCodeNode* base,
                                             ValaCollection* collection);
static void vala_method_finalize (ValaCodeNode * obj);


/**
 * Creates a new method.
 *
 * @param name              method name
 * @param return_type       method return type
 * @param source_reference  reference to source code
 * @return                  newly created method
 */
ValaMethod*
vala_method_construct (GType object_type,
                       const gchar* name,
                       ValaDataType* return_type,
                       ValaSourceReference* source_reference,
                       ValaComment* comment)
{
	ValaMethod* self = NULL;
	g_return_val_if_fail (return_type != NULL, NULL);
	self = (ValaMethod*) vala_subroutine_construct (object_type, name, source_reference, comment);
	vala_callable_set_return_type ((ValaCallable*) self, return_type);
	return self;
}


ValaMethod*
vala_method_new (const gchar* name,
                 ValaDataType* return_type,
                 ValaSourceReference* source_reference,
                 ValaComment* comment)
{
	return vala_method_construct (VALA_TYPE_METHOD, name, return_type, source_reference, comment);
}


/**
 * Appends parameter to this method.
 *
 * @param param a formal parameter
 */
static void
vala_method_real_add_parameter (ValaCallable* base,
                                ValaParameter* param)
{
	ValaMethod * self;
	ValaList* _tmp0_;
	ValaScope* _tmp1_;
	ValaScope* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	self = (ValaMethod*) base;
	g_return_if_fail (param != NULL);
	_tmp0_ = self->priv->parameters;
	vala_collection_add ((ValaCollection*) _tmp0_, param);
	_tmp1_ = vala_symbol_get_scope ((ValaSymbol*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_symbol_get_name ((ValaSymbol*) param);
	_tmp4_ = _tmp3_;
	vala_scope_add (_tmp2_, _tmp4_, (ValaSymbol*) param);
}


static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}


static ValaList*
vala_method_real_get_parameters (ValaCallable* base)
{
	ValaMethod * self;
	ValaList* result = NULL;
	ValaList* _tmp0_;
	ValaList* _tmp1_;
	self = (ValaMethod*) base;
	_tmp0_ = self->priv->parameters;
	_tmp1_ = _vala_iterable_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Remove all parameters from this method.
 */
void
vala_method_clear_parameters (ValaMethod* self)
{
	ValaList* _tmp19_;
	g_return_if_fail (self != NULL);
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _param_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _param_index = 0;
		_tmp0_ = self->priv->parameters;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_param_list = _tmp1_;
		_tmp2_ = _param_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_param_size = _tmp4_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaParameter* param = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaParameter* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
			_tmp5_ = _param_index;
			_param_index = _tmp5_ + 1;
			_tmp6_ = _param_index;
			_tmp7_ = _param_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _param_list;
			_tmp9_ = _param_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			param = (ValaParameter*) _tmp10_;
			_tmp11_ = param;
			_tmp12_ = vala_parameter_get_ellipsis (_tmp11_);
			_tmp13_ = _tmp12_;
			if (!_tmp13_) {
				ValaScope* _tmp14_;
				ValaScope* _tmp15_;
				ValaParameter* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				_tmp14_ = vala_symbol_get_scope ((ValaSymbol*) self);
				_tmp15_ = _tmp14_;
				_tmp16_ = param;
				_tmp17_ = vala_symbol_get_name ((ValaSymbol*) _tmp16_);
				_tmp18_ = _tmp17_;
				vala_scope_remove (_tmp15_, _tmp18_);
			}
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	_tmp19_ = self->priv->parameters;
	vala_collection_clear ((ValaCollection*) _tmp19_);
}


gboolean
vala_method_is_variadic (ValaMethod* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _param_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _param_index = 0;
		_tmp0_ = self->priv->parameters;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_param_list = _tmp1_;
		_tmp2_ = _param_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_param_size = _tmp4_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaParameter* param = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaParameter* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
			_tmp5_ = _param_index;
			_param_index = _tmp5_ + 1;
			_tmp6_ = _param_index;
			_tmp7_ = _param_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _param_list;
			_tmp9_ = _param_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			param = (ValaParameter*) _tmp10_;
			_tmp11_ = param;
			_tmp12_ = vala_parameter_get_ellipsis (_tmp11_);
			_tmp13_ = _tmp12_;
			if (_tmp13_) {
				result = TRUE;
				_vala_code_node_unref0 (param);
				_vala_iterable_unref0 (_param_list);
				return result;
			}
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	result = FALSE;
	return result;
}


static void
vala_method_real_accept (ValaCodeNode* base,
                         ValaCodeVisitor* visitor)
{
	ValaMethod * self;
	self = (ValaMethod*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_method (visitor, self);
}


static void
vala_method_real_accept_children (ValaCodeNode* base,
                                  ValaCodeVisitor* visitor)
{
	ValaMethod * self;
	ValaDataType* _tmp11_;
	ValaDataType* _tmp12_;
	ValaDataType* _tmp15_;
	ValaDataType* _tmp16_;
	ValaLocalVariable* _tmp42_;
	ValaLocalVariable* _tmp43_;
	ValaList* _tmp46_;
	ValaList* _tmp59_;
	ValaBlock* _tmp72_;
	ValaBlock* _tmp73_;
	self = (ValaMethod*) base;
	g_return_if_fail (visitor != NULL);
	{
		ValaList* _p_list = NULL;
		ValaList* _tmp0_;
		gint _p_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _p_index = 0;
		_tmp0_ = vala_method_get_type_parameters (self);
		_p_list = _tmp0_;
		_tmp1_ = _p_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_p_size = _tmp3_;
		_p_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			ValaTypeParameter* p = NULL;
			ValaList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_;
			ValaTypeParameter* _tmp10_;
			_tmp4_ = _p_index;
			_p_index = _tmp4_ + 1;
			_tmp5_ = _p_index;
			_tmp6_ = _p_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _p_list;
			_tmp8_ = _p_index;
			_tmp9_ = vala_list_get (_tmp7_, _tmp8_);
			p = (ValaTypeParameter*) _tmp9_;
			_tmp10_ = p;
			vala_code_node_accept ((ValaCodeNode*) _tmp10_, visitor);
			_vala_code_node_unref0 (p);
		}
		_vala_iterable_unref0 (_p_list);
	}
	_tmp11_ = vala_method_get_base_interface_type (self);
	_tmp12_ = _tmp11_;
	if (_tmp12_ != NULL) {
		ValaDataType* _tmp13_;
		ValaDataType* _tmp14_;
		_tmp13_ = vala_method_get_base_interface_type (self);
		_tmp14_ = _tmp13_;
		vala_code_node_accept ((ValaCodeNode*) _tmp14_, visitor);
	}
	_tmp15_ = vala_callable_get_return_type ((ValaCallable*) self);
	_tmp16_ = _tmp15_;
	if (_tmp16_ != NULL) {
		ValaDataType* _tmp17_;
		ValaDataType* _tmp18_;
		_tmp17_ = vala_callable_get_return_type ((ValaCallable*) self);
		_tmp18_ = _tmp17_;
		vala_code_node_accept ((ValaCodeNode*) _tmp18_, visitor);
	}
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp19_;
		ValaList* _tmp20_;
		gint _param_size = 0;
		ValaList* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		gint _param_index = 0;
		_tmp19_ = self->priv->parameters;
		_tmp20_ = _vala_iterable_ref0 (_tmp19_);
		_param_list = _tmp20_;
		_tmp21_ = _param_list;
		_tmp22_ = vala_collection_get_size ((ValaCollection*) _tmp21_);
		_tmp23_ = _tmp22_;
		_param_size = _tmp23_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			ValaParameter* param = NULL;
			ValaList* _tmp27_;
			gint _tmp28_;
			gpointer _tmp29_;
			ValaParameter* _tmp30_;
			_tmp24_ = _param_index;
			_param_index = _tmp24_ + 1;
			_tmp25_ = _param_index;
			_tmp26_ = _param_size;
			if (!(_tmp25_ < _tmp26_)) {
				break;
			}
			_tmp27_ = _param_list;
			_tmp28_ = _param_index;
			_tmp29_ = vala_list_get (_tmp27_, _tmp28_);
			param = (ValaParameter*) _tmp29_;
			_tmp30_ = param;
			vala_code_node_accept ((ValaCodeNode*) _tmp30_, visitor);
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	{
		ValaList* _error_type_list = NULL;
		ValaList* _tmp31_;
		gint _error_type_size = 0;
		ValaList* _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		gint _error_type_index = 0;
		_tmp31_ = vala_code_node_get_error_types ((ValaCodeNode*) self);
		_error_type_list = _tmp31_;
		_tmp32_ = _error_type_list;
		_tmp33_ = vala_collection_get_size ((ValaCollection*) _tmp32_);
		_tmp34_ = _tmp33_;
		_error_type_size = _tmp34_;
		_error_type_index = -1;
		while (TRUE) {
			gint _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
			ValaDataType* error_type = NULL;
			ValaList* _tmp38_;
			gint _tmp39_;
			gpointer _tmp40_;
			ValaDataType* _tmp41_;
			_tmp35_ = _error_type_index;
			_error_type_index = _tmp35_ + 1;
			_tmp36_ = _error_type_index;
			_tmp37_ = _error_type_size;
			if (!(_tmp36_ < _tmp37_)) {
				break;
			}
			_tmp38_ = _error_type_list;
			_tmp39_ = _error_type_index;
			_tmp40_ = vala_list_get (_tmp38_, _tmp39_);
			error_type = (ValaDataType*) _tmp40_;
			_tmp41_ = error_type;
			vala_code_node_accept ((ValaCodeNode*) _tmp41_, visitor);
			_vala_code_node_unref0 (error_type);
		}
		_vala_iterable_unref0 (_error_type_list);
	}
	_tmp42_ = vala_subroutine_get_result_var ((ValaSubroutine*) self);
	_tmp43_ = _tmp42_;
	if (_tmp43_ != NULL) {
		ValaLocalVariable* _tmp44_;
		ValaLocalVariable* _tmp45_;
		_tmp44_ = vala_subroutine_get_result_var ((ValaSubroutine*) self);
		_tmp45_ = _tmp44_;
		vala_code_node_accept ((ValaCodeNode*) _tmp45_, visitor);
	}
	_tmp46_ = self->priv->preconditions;
	if (_tmp46_ != NULL) {
		{
			ValaList* _precondition_list = NULL;
			ValaList* _tmp47_;
			ValaList* _tmp48_;
			gint _precondition_size = 0;
			ValaList* _tmp49_;
			gint _tmp50_;
			gint _tmp51_;
			gint _precondition_index = 0;
			_tmp47_ = self->priv->preconditions;
			_tmp48_ = _vala_iterable_ref0 (_tmp47_);
			_precondition_list = _tmp48_;
			_tmp49_ = _precondition_list;
			_tmp50_ = vala_collection_get_size ((ValaCollection*) _tmp49_);
			_tmp51_ = _tmp50_;
			_precondition_size = _tmp51_;
			_precondition_index = -1;
			while (TRUE) {
				gint _tmp52_;
				gint _tmp53_;
				gint _tmp54_;
				ValaExpression* precondition = NULL;
				ValaList* _tmp55_;
				gint _tmp56_;
				gpointer _tmp57_;
				ValaExpression* _tmp58_;
				_tmp52_ = _precondition_index;
				_precondition_index = _tmp52_ + 1;
				_tmp53_ = _precondition_index;
				_tmp54_ = _precondition_size;
				if (!(_tmp53_ < _tmp54_)) {
					break;
				}
				_tmp55_ = _precondition_list;
				_tmp56_ = _precondition_index;
				_tmp57_ = vala_list_get (_tmp55_, _tmp56_);
				precondition = (ValaExpression*) _tmp57_;
				_tmp58_ = precondition;
				vala_code_node_accept ((ValaCodeNode*) _tmp58_, visitor);
				_vala_code_node_unref0 (precondition);
			}
			_vala_iterable_unref0 (_precondition_list);
		}
	}
	_tmp59_ = self->priv->postconditions;
	if (_tmp59_ != NULL) {
		{
			ValaList* _postcondition_list = NULL;
			ValaList* _tmp60_;
			ValaList* _tmp61_;
			gint _postcondition_size = 0;
			ValaList* _tmp62_;
			gint _tmp63_;
			gint _tmp64_;
			gint _postcondition_index = 0;
			_tmp60_ = self->priv->postconditions;
			_tmp61_ = _vala_iterable_ref0 (_tmp60_);
			_postcondition_list = _tmp61_;
			_tmp62_ = _postcondition_list;
			_tmp63_ = vala_collection_get_size ((ValaCollection*) _tmp62_);
			_tmp64_ = _tmp63_;
			_postcondition_size = _tmp64_;
			_postcondition_index = -1;
			while (TRUE) {
				gint _tmp65_;
				gint _tmp66_;
				gint _tmp67_;
				ValaExpression* postcondition = NULL;
				ValaList* _tmp68_;
				gint _tmp69_;
				gpointer _tmp70_;
				ValaExpression* _tmp71_;
				_tmp65_ = _postcondition_index;
				_postcondition_index = _tmp65_ + 1;
				_tmp66_ = _postcondition_index;
				_tmp67_ = _postcondition_size;
				if (!(_tmp66_ < _tmp67_)) {
					break;
				}
				_tmp68_ = _postcondition_list;
				_tmp69_ = _postcondition_index;
				_tmp70_ = vala_list_get (_tmp68_, _tmp69_);
				postcondition = (ValaExpression*) _tmp70_;
				_tmp71_ = postcondition;
				vala_code_node_accept ((ValaCodeNode*) _tmp71_, visitor);
				_vala_code_node_unref0 (postcondition);
			}
			_vala_iterable_unref0 (_postcondition_list);
		}
	}
	_tmp72_ = vala_subroutine_get_body ((ValaSubroutine*) self);
	_tmp73_ = _tmp72_;
	if (_tmp73_ != NULL) {
		ValaBlock* _tmp74_;
		ValaBlock* _tmp75_;
		_tmp74_ = vala_subroutine_get_body ((ValaSubroutine*) self);
		_tmp75_ = _tmp74_;
		vala_code_node_accept ((ValaCodeNode*) _tmp75_, visitor);
	}
}


/**
 * Checks whether the parameters and return type of this method are
 * compatible with the specified method
 *
 * @param base_method a method
 * @param invalid_match error string about which check failed
 * @return true if the specified method is compatible to this method
 */
gboolean
vala_method_compatible (ValaMethod* self,
                        ValaMethod* base_method,
                        gchar* * invalid_match)
{
	gchar* _vala_invalid_match = NULL;
	gboolean result = FALSE;
	ValaMemberBinding _tmp0_;
	ValaMemberBinding _tmp1_;
	ValaObjectType* object_type = NULL;
	ValaSymbol* _tmp3_;
	ValaSymbol* _tmp4_;
	ValaList* _tmp26_;
	ValaList* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	ValaList* _tmp30_;
	ValaList* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	gboolean _tmp34_;
	ValaList* method_type_args = NULL;
	ValaList* _tmp46_;
	ValaList* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gboolean _tmp50_;
	ValaDataType* actual_base_type = NULL;
	ValaDataType* _tmp68_;
	ValaDataType* _tmp69_;
	ValaObjectType* _tmp70_;
	ValaList* _tmp71_;
	ValaDataType* _tmp72_;
	ValaDataType* _tmp73_;
	ValaDataType* _tmp74_;
	ValaDataType* _tmp75_;
	ValaIterator* method_params_it = NULL;
	ValaList* _tmp84_;
	ValaIterator* _tmp85_;
	gint param_index = 0;
	ValaIterator* _tmp139_;
	gboolean _tmp168_;
	gboolean _tmp169_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (base_method != NULL, FALSE);
	if (self == base_method) {
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = NULL;
		result = TRUE;
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	}
	_tmp0_ = self->priv->_binding;
	_tmp1_ = base_method->priv->_binding;
	if (_tmp0_ != _tmp1_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("incompatible binding");
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = _tmp2_;
		result = FALSE;
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	}
	object_type = NULL;
	_tmp3_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp4_ = _tmp3_;
	if (VALA_IS_OBJECT_TYPE_SYMBOL (_tmp4_)) {
		ValaSymbol* _tmp5_;
		ValaSymbol* _tmp6_;
		ValaObjectType* _tmp7_;
		_tmp5_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp6_ = _tmp5_;
		_tmp7_ = vala_object_type_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol));
		_vala_code_node_unref0 (object_type);
		object_type = _tmp7_;
		{
			ValaList* _type_parameter_list = NULL;
			ValaObjectType* _tmp8_;
			ValaObjectTypeSymbol* _tmp9_;
			ValaObjectTypeSymbol* _tmp10_;
			ValaList* _tmp11_;
			gint _type_parameter_size = 0;
			ValaList* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _type_parameter_index = 0;
			_tmp8_ = object_type;
			_tmp9_ = vala_object_type_get_type_symbol (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = vala_object_type_symbol_get_type_parameters (_tmp10_);
			_type_parameter_list = _tmp11_;
			_tmp12_ = _type_parameter_list;
			_tmp13_ = vala_collection_get_size ((ValaCollection*) _tmp12_);
			_tmp14_ = _tmp13_;
			_type_parameter_size = _tmp14_;
			_type_parameter_index = -1;
			while (TRUE) {
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				ValaTypeParameter* type_parameter = NULL;
				ValaList* _tmp18_;
				gint _tmp19_;
				gpointer _tmp20_;
				ValaGenericType* type_arg = NULL;
				ValaTypeParameter* _tmp21_;
				ValaGenericType* _tmp22_;
				ValaGenericType* _tmp23_;
				ValaObjectType* _tmp24_;
				ValaGenericType* _tmp25_;
				_tmp15_ = _type_parameter_index;
				_type_parameter_index = _tmp15_ + 1;
				_tmp16_ = _type_parameter_index;
				_tmp17_ = _type_parameter_size;
				if (!(_tmp16_ < _tmp17_)) {
					break;
				}
				_tmp18_ = _type_parameter_list;
				_tmp19_ = _type_parameter_index;
				_tmp20_ = vala_list_get (_tmp18_, _tmp19_);
				type_parameter = (ValaTypeParameter*) _tmp20_;
				_tmp21_ = type_parameter;
				_tmp22_ = vala_generic_type_new (_tmp21_);
				type_arg = _tmp22_;
				_tmp23_ = type_arg;
				vala_data_type_set_value_owned ((ValaDataType*) _tmp23_, TRUE);
				_tmp24_ = object_type;
				_tmp25_ = type_arg;
				vala_data_type_add_type_argument ((ValaDataType*) _tmp24_, (ValaDataType*) _tmp25_);
				_vala_code_node_unref0 (type_arg);
				_vala_code_node_unref0 (type_parameter);
			}
			_vala_iterable_unref0 (_type_parameter_list);
		}
	}
	_tmp26_ = vala_method_get_type_parameters (self);
	_tmp27_ = _tmp26_;
	_tmp28_ = vala_collection_get_size ((ValaCollection*) _tmp27_);
	_tmp29_ = _tmp28_;
	_tmp30_ = vala_method_get_type_parameters (base_method);
	_tmp31_ = _tmp30_;
	_tmp32_ = vala_collection_get_size ((ValaCollection*) _tmp31_);
	_tmp33_ = _tmp32_;
	_tmp34_ = _tmp29_ < _tmp33_;
	_vala_iterable_unref0 (_tmp31_);
	_vala_iterable_unref0 (_tmp27_);
	if (_tmp34_) {
		gchar* _tmp35_;
		_tmp35_ = g_strdup ("too few type parameters");
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = _tmp35_;
		result = FALSE;
		_vala_code_node_unref0 (object_type);
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	} else {
		ValaList* _tmp36_;
		ValaList* _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		ValaList* _tmp40_;
		ValaList* _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		gboolean _tmp44_;
		_tmp36_ = vala_method_get_type_parameters (self);
		_tmp37_ = _tmp36_;
		_tmp38_ = vala_collection_get_size ((ValaCollection*) _tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = vala_method_get_type_parameters (base_method);
		_tmp41_ = _tmp40_;
		_tmp42_ = vala_collection_get_size ((ValaCollection*) _tmp41_);
		_tmp43_ = _tmp42_;
		_tmp44_ = _tmp39_ > _tmp43_;
		_vala_iterable_unref0 (_tmp41_);
		_vala_iterable_unref0 (_tmp37_);
		if (_tmp44_) {
			gchar* _tmp45_;
			_tmp45_ = g_strdup ("too many type parameters");
			_g_free0 (_vala_invalid_match);
			_vala_invalid_match = _tmp45_;
			result = FALSE;
			_vala_code_node_unref0 (object_type);
			if (invalid_match) {
				*invalid_match = _vala_invalid_match;
			} else {
				_g_free0 (_vala_invalid_match);
			}
			return result;
		}
	}
	method_type_args = NULL;
	_tmp46_ = vala_method_get_type_parameters (self);
	_tmp47_ = _tmp46_;
	_tmp48_ = vala_collection_get_size ((ValaCollection*) _tmp47_);
	_tmp49_ = _tmp48_;
	_tmp50_ = _tmp49_ > 0;
	_vala_iterable_unref0 (_tmp47_);
	if (_tmp50_) {
		GEqualFunc _tmp51_;
		ValaArrayList* _tmp52_;
		_tmp51_ = g_direct_equal;
		_tmp52_ = vala_array_list_new (VALA_TYPE_DATA_TYPE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp51_);
		_vala_iterable_unref0 (method_type_args);
		method_type_args = (ValaList*) _tmp52_;
		{
			ValaList* _type_parameter_list = NULL;
			ValaList* _tmp53_;
			gint _type_parameter_size = 0;
			ValaList* _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
			gint _type_parameter_index = 0;
			_tmp53_ = vala_method_get_type_parameters (self);
			_type_parameter_list = _tmp53_;
			_tmp54_ = _type_parameter_list;
			_tmp55_ = vala_collection_get_size ((ValaCollection*) _tmp54_);
			_tmp56_ = _tmp55_;
			_type_parameter_size = _tmp56_;
			_type_parameter_index = -1;
			while (TRUE) {
				gint _tmp57_;
				gint _tmp58_;
				gint _tmp59_;
				ValaTypeParameter* type_parameter = NULL;
				ValaList* _tmp60_;
				gint _tmp61_;
				gpointer _tmp62_;
				ValaGenericType* type_arg = NULL;
				ValaTypeParameter* _tmp63_;
				ValaGenericType* _tmp64_;
				ValaGenericType* _tmp65_;
				ValaList* _tmp66_;
				ValaGenericType* _tmp67_;
				_tmp57_ = _type_parameter_index;
				_type_parameter_index = _tmp57_ + 1;
				_tmp58_ = _type_parameter_index;
				_tmp59_ = _type_parameter_size;
				if (!(_tmp58_ < _tmp59_)) {
					break;
				}
				_tmp60_ = _type_parameter_list;
				_tmp61_ = _type_parameter_index;
				_tmp62_ = vala_list_get (_tmp60_, _tmp61_);
				type_parameter = (ValaTypeParameter*) _tmp62_;
				_tmp63_ = type_parameter;
				_tmp64_ = vala_generic_type_new (_tmp63_);
				type_arg = _tmp64_;
				_tmp65_ = type_arg;
				vala_data_type_set_value_owned ((ValaDataType*) _tmp65_, TRUE);
				_tmp66_ = method_type_args;
				_tmp67_ = type_arg;
				vala_collection_add ((ValaCollection*) _tmp66_, (ValaDataType*) _tmp67_);
				_vala_code_node_unref0 (type_arg);
				_vala_code_node_unref0 (type_parameter);
			}
			_vala_iterable_unref0 (_type_parameter_list);
		}
	}
	_tmp68_ = vala_callable_get_return_type ((ValaCallable*) base_method);
	_tmp69_ = _tmp68_;
	_tmp70_ = object_type;
	_tmp71_ = method_type_args;
	_tmp72_ = vala_data_type_get_actual_type (_tmp69_, (ValaDataType*) _tmp70_, _tmp71_, (ValaCodeNode*) self);
	actual_base_type = _tmp72_;
	_tmp73_ = vala_callable_get_return_type ((ValaCallable*) self);
	_tmp74_ = _tmp73_;
	_tmp75_ = actual_base_type;
	if (!vala_data_type_equals (_tmp74_, _tmp75_)) {
		ValaDataType* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		ValaDataType* _tmp79_;
		ValaDataType* _tmp80_;
		gchar* _tmp81_;
		gchar* _tmp82_;
		gchar* _tmp83_;
		_tmp76_ = actual_base_type;
		_tmp77_ = vala_data_type_to_prototype_string (_tmp76_, NULL);
		_tmp78_ = _tmp77_;
		_tmp79_ = vala_callable_get_return_type ((ValaCallable*) self);
		_tmp80_ = _tmp79_;
		_tmp81_ = vala_data_type_to_prototype_string (_tmp80_, NULL);
		_tmp82_ = _tmp81_;
		_tmp83_ = g_strdup_printf ("Base method expected return type `%s', but `%s' was provided", _tmp78_, _tmp82_);
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = _tmp83_;
		_g_free0 (_tmp82_);
		_g_free0 (_tmp78_);
		result = FALSE;
		_vala_code_node_unref0 (actual_base_type);
		_vala_iterable_unref0 (method_type_args);
		_vala_code_node_unref0 (object_type);
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	}
	_tmp84_ = self->priv->parameters;
	_tmp85_ = vala_iterable_iterator ((ValaIterable*) _tmp84_);
	method_params_it = _tmp85_;
	param_index = 1;
	{
		ValaList* _base_param_list = NULL;
		ValaList* _tmp86_;
		ValaList* _tmp87_;
		gint _base_param_size = 0;
		ValaList* _tmp88_;
		gint _tmp89_;
		gint _tmp90_;
		gint _base_param_index = 0;
		_tmp86_ = base_method->priv->parameters;
		_tmp87_ = _vala_iterable_ref0 (_tmp86_);
		_base_param_list = _tmp87_;
		_tmp88_ = _base_param_list;
		_tmp89_ = vala_collection_get_size ((ValaCollection*) _tmp88_);
		_tmp90_ = _tmp89_;
		_base_param_size = _tmp90_;
		_base_param_index = -1;
		while (TRUE) {
			gint _tmp91_;
			gint _tmp92_;
			gint _tmp93_;
			ValaParameter* base_param = NULL;
			ValaList* _tmp94_;
			gint _tmp95_;
			gpointer _tmp96_;
			ValaIterator* _tmp97_;
			ValaParameter* param = NULL;
			ValaIterator* _tmp99_;
			gpointer _tmp100_;
			ValaParameter* _tmp101_;
			gboolean _tmp102_;
			gboolean _tmp103_;
			ValaParameter* _tmp104_;
			gboolean _tmp105_;
			gboolean _tmp106_;
			ValaParameter* _tmp108_;
			gboolean _tmp109_;
			gboolean _tmp110_;
			ValaParameter* _tmp111_;
			gboolean _tmp112_;
			gboolean _tmp113_;
			ValaParameter* _tmp115_;
			gboolean _tmp116_;
			gboolean _tmp117_;
			gint _tmp138_;
			_tmp91_ = _base_param_index;
			_base_param_index = _tmp91_ + 1;
			_tmp92_ = _base_param_index;
			_tmp93_ = _base_param_size;
			if (!(_tmp92_ < _tmp93_)) {
				break;
			}
			_tmp94_ = _base_param_list;
			_tmp95_ = _base_param_index;
			_tmp96_ = vala_list_get (_tmp94_, _tmp95_);
			base_param = (ValaParameter*) _tmp96_;
			_tmp97_ = method_params_it;
			if (!vala_iterator_next (_tmp97_)) {
				gchar* _tmp98_;
				_tmp98_ = g_strdup ("too few parameters");
				_g_free0 (_vala_invalid_match);
				_vala_invalid_match = _tmp98_;
				result = FALSE;
				_vala_code_node_unref0 (base_param);
				_vala_iterable_unref0 (_base_param_list);
				_vala_iterator_unref0 (method_params_it);
				_vala_code_node_unref0 (actual_base_type);
				_vala_iterable_unref0 (method_type_args);
				_vala_code_node_unref0 (object_type);
				if (invalid_match) {
					*invalid_match = _vala_invalid_match;
				} else {
					_g_free0 (_vala_invalid_match);
				}
				return result;
			}
			_tmp99_ = method_params_it;
			_tmp100_ = vala_iterator_get (_tmp99_);
			param = (ValaParameter*) _tmp100_;
			_tmp101_ = base_param;
			_tmp102_ = vala_parameter_get_ellipsis (_tmp101_);
			_tmp103_ = _tmp102_;
			_tmp104_ = param;
			_tmp105_ = vala_parameter_get_ellipsis (_tmp104_);
			_tmp106_ = _tmp105_;
			if (_tmp103_ != _tmp106_) {
				gchar* _tmp107_;
				_tmp107_ = g_strdup ("ellipsis parameter mismatch");
				_g_free0 (_vala_invalid_match);
				_vala_invalid_match = _tmp107_;
				result = FALSE;
				_vala_code_node_unref0 (param);
				_vala_code_node_unref0 (base_param);
				_vala_iterable_unref0 (_base_param_list);
				_vala_iterator_unref0 (method_params_it);
				_vala_code_node_unref0 (actual_base_type);
				_vala_iterable_unref0 (method_type_args);
				_vala_code_node_unref0 (object_type);
				if (invalid_match) {
					*invalid_match = _vala_invalid_match;
				} else {
					_g_free0 (_vala_invalid_match);
				}
				return result;
			}
			_tmp108_ = base_param;
			_tmp109_ = vala_parameter_get_params_array (_tmp108_);
			_tmp110_ = _tmp109_;
			_tmp111_ = param;
			_tmp112_ = vala_parameter_get_params_array (_tmp111_);
			_tmp113_ = _tmp112_;
			if (_tmp110_ != _tmp113_) {
				gchar* _tmp114_;
				_tmp114_ = g_strdup ("params array parameter mismatch");
				_g_free0 (_vala_invalid_match);
				_vala_invalid_match = _tmp114_;
				result = FALSE;
				_vala_code_node_unref0 (param);
				_vala_code_node_unref0 (base_param);
				_vala_iterable_unref0 (_base_param_list);
				_vala_iterator_unref0 (method_params_it);
				_vala_code_node_unref0 (actual_base_type);
				_vala_iterable_unref0 (method_type_args);
				_vala_code_node_unref0 (object_type);
				if (invalid_match) {
					*invalid_match = _vala_invalid_match;
				} else {
					_g_free0 (_vala_invalid_match);
				}
				return result;
			}
			_tmp115_ = base_param;
			_tmp116_ = vala_parameter_get_ellipsis (_tmp115_);
			_tmp117_ = _tmp116_;
			if (!_tmp117_) {
				ValaParameter* _tmp118_;
				ValaParameterDirection _tmp119_;
				ValaParameterDirection _tmp120_;
				ValaParameter* _tmp121_;
				ValaParameterDirection _tmp122_;
				ValaParameterDirection _tmp123_;
				ValaParameter* _tmp126_;
				ValaDataType* _tmp127_;
				ValaDataType* _tmp128_;
				ValaObjectType* _tmp129_;
				ValaList* _tmp130_;
				ValaDataType* _tmp131_;
				ValaDataType* _tmp132_;
				ValaParameter* _tmp133_;
				ValaDataType* _tmp134_;
				ValaDataType* _tmp135_;
				_tmp118_ = base_param;
				_tmp119_ = vala_parameter_get_direction (_tmp118_);
				_tmp120_ = _tmp119_;
				_tmp121_ = param;
				_tmp122_ = vala_parameter_get_direction (_tmp121_);
				_tmp123_ = _tmp122_;
				if (_tmp120_ != _tmp123_) {
					gint _tmp124_;
					gchar* _tmp125_;
					_tmp124_ = param_index;
					_tmp125_ = g_strdup_printf ("incompatible direction of parameter %d", _tmp124_);
					_g_free0 (_vala_invalid_match);
					_vala_invalid_match = _tmp125_;
					result = FALSE;
					_vala_code_node_unref0 (param);
					_vala_code_node_unref0 (base_param);
					_vala_iterable_unref0 (_base_param_list);
					_vala_iterator_unref0 (method_params_it);
					_vala_code_node_unref0 (actual_base_type);
					_vala_iterable_unref0 (method_type_args);
					_vala_code_node_unref0 (object_type);
					if (invalid_match) {
						*invalid_match = _vala_invalid_match;
					} else {
						_g_free0 (_vala_invalid_match);
					}
					return result;
				}
				_tmp126_ = base_param;
				_tmp127_ = vala_variable_get_variable_type ((ValaVariable*) _tmp126_);
				_tmp128_ = _tmp127_;
				_tmp129_ = object_type;
				_tmp130_ = method_type_args;
				_tmp131_ = vala_data_type_get_actual_type (_tmp128_, (ValaDataType*) _tmp129_, _tmp130_, (ValaCodeNode*) self);
				_vala_code_node_unref0 (actual_base_type);
				actual_base_type = _tmp131_;
				_tmp132_ = actual_base_type;
				_tmp133_ = param;
				_tmp134_ = vala_variable_get_variable_type ((ValaVariable*) _tmp133_);
				_tmp135_ = _tmp134_;
				if (!vala_data_type_equals (_tmp132_, _tmp135_)) {
					gint _tmp136_;
					gchar* _tmp137_;
					_tmp136_ = param_index;
					_tmp137_ = g_strdup_printf ("incompatible type of parameter %d", _tmp136_);
					_g_free0 (_vala_invalid_match);
					_vala_invalid_match = _tmp137_;
					result = FALSE;
					_vala_code_node_unref0 (param);
					_vala_code_node_unref0 (base_param);
					_vala_iterable_unref0 (_base_param_list);
					_vala_iterator_unref0 (method_params_it);
					_vala_code_node_unref0 (actual_base_type);
					_vala_iterable_unref0 (method_type_args);
					_vala_code_node_unref0 (object_type);
					if (invalid_match) {
						*invalid_match = _vala_invalid_match;
					} else {
						_g_free0 (_vala_invalid_match);
					}
					return result;
				}
			}
			_tmp138_ = param_index;
			param_index = _tmp138_ + 1;
			_vala_code_node_unref0 (param);
			_vala_code_node_unref0 (base_param);
		}
		_vala_iterable_unref0 (_base_param_list);
	}
	_tmp139_ = method_params_it;
	if (vala_iterator_next (_tmp139_)) {
		gchar* _tmp140_;
		_tmp140_ = g_strdup ("too many parameters");
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = _tmp140_;
		result = FALSE;
		_vala_iterator_unref0 (method_params_it);
		_vala_code_node_unref0 (actual_base_type);
		_vala_iterable_unref0 (method_type_args);
		_vala_code_node_unref0 (object_type);
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	}
	{
		ValaList* _method_error_type_list = NULL;
		ValaList* _tmp141_;
		gint _method_error_type_size = 0;
		ValaList* _tmp142_;
		gint _tmp143_;
		gint _tmp144_;
		gint _method_error_type_index = 0;
		_tmp141_ = vala_code_node_get_error_types ((ValaCodeNode*) self);
		_method_error_type_list = _tmp141_;
		_tmp142_ = _method_error_type_list;
		_tmp143_ = vala_collection_get_size ((ValaCollection*) _tmp142_);
		_tmp144_ = _tmp143_;
		_method_error_type_size = _tmp144_;
		_method_error_type_index = -1;
		while (TRUE) {
			gint _tmp145_;
			gint _tmp146_;
			gint _tmp147_;
			ValaDataType* method_error_type = NULL;
			ValaList* _tmp148_;
			gint _tmp149_;
			gpointer _tmp150_;
			gboolean match = FALSE;
			gboolean _tmp163_;
			_tmp145_ = _method_error_type_index;
			_method_error_type_index = _tmp145_ + 1;
			_tmp146_ = _method_error_type_index;
			_tmp147_ = _method_error_type_size;
			if (!(_tmp146_ < _tmp147_)) {
				break;
			}
			_tmp148_ = _method_error_type_list;
			_tmp149_ = _method_error_type_index;
			_tmp150_ = vala_list_get (_tmp148_, _tmp149_);
			method_error_type = (ValaDataType*) _tmp150_;
			match = FALSE;
			{
				ValaList* _base_method_error_type_list = NULL;
				ValaList* _tmp151_;
				gint _base_method_error_type_size = 0;
				ValaList* _tmp152_;
				gint _tmp153_;
				gint _tmp154_;
				gint _base_method_error_type_index = 0;
				_tmp151_ = vala_code_node_get_error_types ((ValaCodeNode*) base_method);
				_base_method_error_type_list = _tmp151_;
				_tmp152_ = _base_method_error_type_list;
				_tmp153_ = vala_collection_get_size ((ValaCollection*) _tmp152_);
				_tmp154_ = _tmp153_;
				_base_method_error_type_size = _tmp154_;
				_base_method_error_type_index = -1;
				while (TRUE) {
					gint _tmp155_;
					gint _tmp156_;
					gint _tmp157_;
					ValaDataType* base_method_error_type = NULL;
					ValaList* _tmp158_;
					gint _tmp159_;
					gpointer _tmp160_;
					ValaDataType* _tmp161_;
					ValaDataType* _tmp162_;
					_tmp155_ = _base_method_error_type_index;
					_base_method_error_type_index = _tmp155_ + 1;
					_tmp156_ = _base_method_error_type_index;
					_tmp157_ = _base_method_error_type_size;
					if (!(_tmp156_ < _tmp157_)) {
						break;
					}
					_tmp158_ = _base_method_error_type_list;
					_tmp159_ = _base_method_error_type_index;
					_tmp160_ = vala_list_get (_tmp158_, _tmp159_);
					base_method_error_type = (ValaDataType*) _tmp160_;
					_tmp161_ = method_error_type;
					_tmp162_ = base_method_error_type;
					if (vala_data_type_compatible (_tmp161_, _tmp162_)) {
						match = TRUE;
						_vala_code_node_unref0 (base_method_error_type);
						break;
					}
					_vala_code_node_unref0 (base_method_error_type);
				}
				_vala_iterable_unref0 (_base_method_error_type_list);
			}
			_tmp163_ = match;
			if (!_tmp163_) {
				ValaDataType* _tmp164_;
				gchar* _tmp165_;
				gchar* _tmp166_;
				gchar* _tmp167_;
				_tmp164_ = method_error_type;
				_tmp165_ = vala_code_node_to_string ((ValaCodeNode*) _tmp164_);
				_tmp166_ = _tmp165_;
				_tmp167_ = g_strdup_printf ("incompatible error type `%s'", _tmp166_);
				_g_free0 (_vala_invalid_match);
				_vala_invalid_match = _tmp167_;
				_g_free0 (_tmp166_);
				result = FALSE;
				_vala_code_node_unref0 (method_error_type);
				_vala_iterable_unref0 (_method_error_type_list);
				_vala_iterator_unref0 (method_params_it);
				_vala_code_node_unref0 (actual_base_type);
				_vala_iterable_unref0 (method_type_args);
				_vala_code_node_unref0 (object_type);
				if (invalid_match) {
					*invalid_match = _vala_invalid_match;
				} else {
					_g_free0 (_vala_invalid_match);
				}
				return result;
			}
			_vala_code_node_unref0 (method_error_type);
		}
		_vala_iterable_unref0 (_method_error_type_list);
	}
	_tmp168_ = base_method->priv->_coroutine;
	_tmp169_ = self->priv->_coroutine;
	if (_tmp168_ != _tmp169_) {
		gchar* _tmp170_;
		_tmp170_ = g_strdup ("async mismatch");
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = _tmp170_;
		result = FALSE;
		_vala_iterator_unref0 (method_params_it);
		_vala_code_node_unref0 (actual_base_type);
		_vala_iterable_unref0 (method_type_args);
		_vala_code_node_unref0 (object_type);
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	}
	_g_free0 (_vala_invalid_match);
	_vala_invalid_match = NULL;
	result = TRUE;
	_vala_iterator_unref0 (method_params_it);
	_vala_code_node_unref0 (actual_base_type);
	_vala_iterable_unref0 (method_type_args);
	_vala_code_node_unref0 (object_type);
	if (invalid_match) {
		*invalid_match = _vala_invalid_match;
	} else {
		_g_free0 (_vala_invalid_match);
	}
	return result;
}


/**
 * Appends the specified parameter to the list of type parameters.
 *
 * @param p a type parameter
 */
void
vala_method_add_type_parameter (ValaMethod* self,
                                ValaTypeParameter* p)
{
	ValaList* _tmp0_;
	ValaList* _tmp3_;
	ValaScope* _tmp4_;
	ValaScope* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->type_parameters;
	if (_tmp0_ == NULL) {
		GEqualFunc _tmp1_;
		ValaArrayList* _tmp2_;
		_tmp1_ = g_direct_equal;
		_tmp2_ = vala_array_list_new (VALA_TYPE_TYPEPARAMETER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp1_);
		_vala_iterable_unref0 (self->priv->type_parameters);
		self->priv->type_parameters = (ValaList*) _tmp2_;
	}
	_tmp3_ = self->priv->type_parameters;
	vala_collection_add ((ValaCollection*) _tmp3_, p);
	_tmp4_ = vala_symbol_get_scope ((ValaSymbol*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_symbol_get_name ((ValaSymbol*) p);
	_tmp7_ = _tmp6_;
	vala_scope_add (_tmp5_, _tmp7_, (ValaSymbol*) p);
}


/**
 * Returns a copy of the type parameter list.
 *
 * @return list of type parameters
 */
ValaList*
vala_method_get_type_parameters (ValaMethod* self)
{
	ValaList* result = NULL;
	ValaList* _tmp0_;
	ValaList* _tmp3_;
	ValaList* _tmp6_;
	ValaList* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->type_parameters;
	if (_tmp0_ != NULL) {
		ValaList* _tmp1_;
		ValaList* _tmp2_;
		_tmp1_ = self->priv->type_parameters;
		_tmp2_ = _vala_iterable_ref0 (_tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = vala_method__empty_type_parameter_list;
	if (_tmp3_ == NULL) {
		GEqualFunc _tmp4_;
		ValaArrayList* _tmp5_;
		_tmp4_ = g_direct_equal;
		_tmp5_ = vala_array_list_new (VALA_TYPE_TYPEPARAMETER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp4_);
		_vala_iterable_unref0 (vala_method__empty_type_parameter_list);
		vala_method__empty_type_parameter_list = (ValaList*) _tmp5_;
	}
	_tmp6_ = vala_method__empty_type_parameter_list;
	_tmp7_ = _vala_iterable_ref0 (_tmp6_);
	result = _tmp7_;
	return result;
}


gint
vala_method_get_type_parameter_index (ValaMethod* self,
                                      const gchar* name)
{
	gint result = 0;
	ValaList* _tmp0_;
	gint i = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (name != NULL, 0);
	_tmp0_ = self->priv->type_parameters;
	if (_tmp0_ == NULL) {
		result = -1;
		return result;
	}
	i = 0;
	{
		ValaList* _parameter_list = NULL;
		ValaList* _tmp1_;
		ValaList* _tmp2_;
		gint _parameter_size = 0;
		ValaList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _parameter_index = 0;
		_tmp1_ = self->priv->type_parameters;
		_tmp2_ = _vala_iterable_ref0 (_tmp1_);
		_parameter_list = _tmp2_;
		_tmp3_ = _parameter_list;
		_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_parameter_size = _tmp5_;
		_parameter_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			ValaTypeParameter* parameter = NULL;
			ValaList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			ValaTypeParameter* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gint _tmp15_;
			_tmp6_ = _parameter_index;
			_parameter_index = _tmp6_ + 1;
			_tmp7_ = _parameter_index;
			_tmp8_ = _parameter_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _parameter_list;
			_tmp10_ = _parameter_index;
			_tmp11_ = vala_list_get (_tmp9_, _tmp10_);
			parameter = (ValaTypeParameter*) _tmp11_;
			_tmp12_ = parameter;
			_tmp13_ = vala_symbol_get_name ((ValaSymbol*) _tmp12_);
			_tmp14_ = _tmp13_;
			if (g_strcmp0 (_tmp14_, name) == 0) {
				result = i;
				_vala_code_node_unref0 (parameter);
				_vala_iterable_unref0 (_parameter_list);
				return result;
			}
			_tmp15_ = i;
			i = _tmp15_ + 1;
			_vala_code_node_unref0 (parameter);
		}
		_vala_iterable_unref0 (_parameter_list);
	}
	result = -1;
	return result;
}


/**
 * Adds a precondition to this method.
 *
 * @param precondition a boolean precondition expression
 */
void
vala_method_add_precondition (ValaMethod* self,
                              ValaExpression* precondition)
{
	ValaList* _tmp0_;
	ValaList* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (precondition != NULL);
	_tmp0_ = self->priv->preconditions;
	if (_tmp0_ == NULL) {
		GEqualFunc _tmp1_;
		ValaArrayList* _tmp2_;
		_tmp1_ = g_direct_equal;
		_tmp2_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp1_);
		_vala_iterable_unref0 (self->priv->preconditions);
		self->priv->preconditions = (ValaList*) _tmp2_;
	}
	_tmp3_ = self->priv->preconditions;
	vala_collection_add ((ValaCollection*) _tmp3_, precondition);
	vala_code_node_set_parent_node ((ValaCodeNode*) precondition, (ValaCodeNode*) self);
}


/**
 * Returns a copy of the list of preconditions of this method.
 *
 * @return list of preconditions
 */
ValaList*
vala_method_get_preconditions (ValaMethod* self)
{
	ValaList* result = NULL;
	ValaList* _tmp0_;
	ValaList* _tmp3_;
	ValaList* _tmp6_;
	ValaList* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->preconditions;
	if (_tmp0_ != NULL) {
		ValaList* _tmp1_;
		ValaList* _tmp2_;
		_tmp1_ = self->priv->preconditions;
		_tmp2_ = _vala_iterable_ref0 (_tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = vala_method__empty_expression_list;
	if (_tmp3_ == NULL) {
		GEqualFunc _tmp4_;
		ValaArrayList* _tmp5_;
		_tmp4_ = g_direct_equal;
		_tmp5_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp4_);
		_vala_iterable_unref0 (vala_method__empty_expression_list);
		vala_method__empty_expression_list = (ValaList*) _tmp5_;
	}
	_tmp6_ = vala_method__empty_expression_list;
	_tmp7_ = _vala_iterable_ref0 (_tmp6_);
	result = _tmp7_;
	return result;
}


/**
 * Adds a postcondition to this method.
 *
 * @param postcondition a boolean postcondition expression
 */
void
vala_method_add_postcondition (ValaMethod* self,
                               ValaExpression* postcondition)
{
	ValaList* _tmp0_;
	ValaList* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (postcondition != NULL);
	_tmp0_ = self->priv->postconditions;
	if (_tmp0_ == NULL) {
		GEqualFunc _tmp1_;
		ValaArrayList* _tmp2_;
		_tmp1_ = g_direct_equal;
		_tmp2_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp1_);
		_vala_iterable_unref0 (self->priv->postconditions);
		self->priv->postconditions = (ValaList*) _tmp2_;
	}
	_tmp3_ = self->priv->postconditions;
	vala_collection_add ((ValaCollection*) _tmp3_, postcondition);
	vala_code_node_set_parent_node ((ValaCodeNode*) postcondition, (ValaCodeNode*) self);
}


/**
 * Returns a copy of the list of postconditions of this method.
 *
 * @return list of postconditions
 */
ValaList*
vala_method_get_postconditions (ValaMethod* self)
{
	ValaList* result = NULL;
	ValaList* _tmp0_;
	ValaList* _tmp3_;
	ValaList* _tmp6_;
	ValaList* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->postconditions;
	if (_tmp0_ != NULL) {
		ValaList* _tmp1_;
		ValaList* _tmp2_;
		_tmp1_ = self->priv->postconditions;
		_tmp2_ = _vala_iterable_ref0 (_tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = vala_method__empty_expression_list;
	if (_tmp3_ == NULL) {
		GEqualFunc _tmp4_;
		ValaArrayList* _tmp5_;
		_tmp4_ = g_direct_equal;
		_tmp5_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp4_);
		_vala_iterable_unref0 (vala_method__empty_expression_list);
		vala_method__empty_expression_list = (ValaList*) _tmp5_;
	}
	_tmp6_ = vala_method__empty_expression_list;
	_tmp7_ = _vala_iterable_ref0 (_tmp6_);
	result = _tmp7_;
	return result;
}


static void
vala_method_real_replace_type (ValaCodeNode* base,
                               ValaDataType* old_type,
                               ValaDataType* new_type)
{
	ValaMethod * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	ValaDataType* _tmp2_;
	ValaDataType* _tmp3_;
	ValaList* error_types = NULL;
	ValaList* _tmp4_;
	self = (ValaMethod*) base;
	g_return_if_fail (old_type != NULL);
	g_return_if_fail (new_type != NULL);
	_tmp0_ = vala_method_get_base_interface_type (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_type) {
		vala_method_set_base_interface_type (self, new_type);
		return;
	}
	_tmp2_ = vala_callable_get_return_type ((ValaCallable*) self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == old_type) {
		vala_callable_set_return_type ((ValaCallable*) self, new_type);
		return;
	}
	_tmp4_ = vala_code_node_get_error_types ((ValaCodeNode*) self);
	error_types = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				ValaList* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				ValaList* _tmp11_;
				gint _tmp12_;
				gpointer _tmp13_;
				ValaDataType* _tmp14_;
				gboolean _tmp15_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = i;
				_tmp8_ = error_types;
				_tmp9_ = vala_collection_get_size ((ValaCollection*) _tmp8_);
				_tmp10_ = _tmp9_;
				if (!(_tmp7_ < _tmp10_)) {
					break;
				}
				_tmp11_ = error_types;
				_tmp12_ = i;
				_tmp13_ = vala_list_get (_tmp11_, _tmp12_);
				_tmp14_ = (ValaDataType*) _tmp13_;
				_tmp15_ = _tmp14_ == old_type;
				_vala_code_node_unref0 (_tmp14_);
				if (_tmp15_) {
					ValaList* _tmp16_;
					gint _tmp17_;
					_tmp16_ = error_types;
					_tmp17_ = i;
					vala_list_set (_tmp16_, _tmp17_, new_type);
					_vala_iterable_unref0 (error_types);
					return;
				}
			}
		}
	}
	_vala_iterable_unref0 (error_types);
}


static void
vala_method_find_base_methods (ValaMethod* self)
{
	gboolean _tmp0_;
	ValaSymbol* _tmp1_;
	ValaSymbol* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->base_methods_valid;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp2_ = _tmp1_;
	if (VALA_IS_CLASS (_tmp2_)) {
		if (!VALA_IS_CREATION_METHOD (self)) {
			ValaSymbol* _tmp3_;
			ValaSymbol* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			_tmp3_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp4_ = _tmp3_;
			vala_method_find_base_interface_method (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, VALA_TYPE_CLASS, ValaClass));
			_tmp7_ = self->priv->_is_virtual;
			if (_tmp7_) {
				_tmp6_ = TRUE;
			} else {
				gboolean _tmp8_;
				_tmp8_ = self->priv->_is_abstract;
				_tmp6_ = _tmp8_;
			}
			if (_tmp6_) {
				_tmp5_ = TRUE;
			} else {
				gboolean _tmp9_;
				_tmp9_ = self->priv->_overrides;
				_tmp5_ = _tmp9_;
			}
			if (_tmp5_) {
				ValaSymbol* _tmp10_;
				ValaSymbol* _tmp11_;
				_tmp10_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
				_tmp11_ = _tmp10_;
				vala_method_find_base_class_method (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, VALA_TYPE_CLASS, ValaClass));
			}
		}
	} else {
		ValaSymbol* _tmp12_;
		ValaSymbol* _tmp13_;
		_tmp12_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp13_ = _tmp12_;
		if (VALA_IS_INTERFACE (_tmp13_)) {
			gboolean _tmp14_ = FALSE;
			gboolean _tmp15_;
			_tmp15_ = self->priv->_is_virtual;
			if (_tmp15_) {
				_tmp14_ = TRUE;
			} else {
				gboolean _tmp16_;
				_tmp16_ = self->priv->_is_abstract;
				_tmp14_ = _tmp16_;
			}
			if (_tmp14_) {
				self->priv->_base_interface_method = self;
			}
		}
	}
	self->priv->base_methods_valid = TRUE;
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


static void
vala_method_find_base_class_method (ValaMethod* self,
                                    ValaClass* cl)
{
	ValaSymbol* sym = NULL;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	ValaSymbol* _tmp4_;
	ValaSymbol* _tmp5_;
	ValaSymbol* _tmp12_;
	ValaClass* _tmp37_;
	ValaClass* _tmp38_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cl != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) cl);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_symbol_get_name ((ValaSymbol*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_scope_lookup (_tmp1_, _tmp3_);
	sym = _tmp4_;
	_tmp5_ = sym;
	if (VALA_IS_SIGNAL (_tmp5_)) {
		ValaSignal* sig = NULL;
		ValaSymbol* _tmp6_;
		ValaSignal* _tmp7_;
		ValaSignal* _tmp8_;
		ValaMethod* _tmp9_;
		ValaMethod* _tmp10_;
		ValaSymbol* _tmp11_;
		_tmp6_ = sym;
		_tmp7_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_SIGNAL, ValaSignal));
		sig = _tmp7_;
		_tmp8_ = sig;
		_tmp9_ = vala_signal_get_default_handler (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp10_);
		_vala_code_node_unref0 (sym);
		sym = _tmp11_;
		_vala_code_node_unref0 (sig);
	}
	_tmp12_ = sym;
	if (VALA_IS_METHOD (_tmp12_)) {
		ValaMethod* base_method = NULL;
		ValaSymbol* _tmp13_;
		ValaMethod* _tmp14_;
		gboolean _tmp15_ = FALSE;
		ValaMethod* _tmp16_;
		gboolean _tmp17_;
		_tmp13_ = sym;
		_tmp14_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, VALA_TYPE_METHOD, ValaMethod));
		base_method = _tmp14_;
		_tmp16_ = base_method;
		_tmp17_ = _tmp16_->priv->_is_abstract;
		if (_tmp17_) {
			_tmp15_ = TRUE;
		} else {
			ValaMethod* _tmp18_;
			gboolean _tmp19_;
			_tmp18_ = base_method;
			_tmp19_ = _tmp18_->priv->_is_virtual;
			_tmp15_ = _tmp19_;
		}
		if (_tmp15_) {
			gchar* invalid_match = NULL;
			ValaMethod* _tmp20_;
			gchar* _tmp21_ = NULL;
			gboolean _tmp22_;
			ValaMethod* _tmp35_;
			ValaMethod* _tmp36_;
			_tmp20_ = base_method;
			_tmp22_ = vala_method_compatible (self, _tmp20_, &_tmp21_);
			_g_free0 (invalid_match);
			invalid_match = _tmp21_;
			if (!_tmp22_) {
				ValaMethodType* base_method_type = NULL;
				ValaMethod* _tmp23_;
				ValaMethodType* _tmp24_;
				ValaSourceReference* _tmp25_;
				ValaSourceReference* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				ValaMethodType* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				const gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp23_ = base_method;
				_tmp24_ = vala_method_type_new (_tmp23_);
				base_method_type = _tmp24_;
				_tmp25_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp26_ = _tmp25_;
				_tmp27_ = vala_symbol_get_full_name ((ValaSymbol*) self);
				_tmp28_ = _tmp27_;
				_tmp29_ = base_method_type;
				_tmp30_ = vala_data_type_to_prototype_string ((ValaDataType*) _tmp29_, NULL);
				_tmp31_ = _tmp30_;
				_tmp32_ = invalid_match;
				_tmp33_ = g_strdup_printf ("overriding method `%s' is incompatible with base method `%s': %s.", _tmp28_, _tmp31_, _tmp32_);
				_tmp34_ = _tmp33_;
				vala_report_error (_tmp26_, _tmp34_);
				_g_free0 (_tmp34_);
				_g_free0 (_tmp31_);
				_g_free0 (_tmp28_);
				_vala_code_node_unref0 (base_method_type);
				_g_free0 (invalid_match);
				_vala_code_node_unref0 (base_method);
				_vala_code_node_unref0 (sym);
				return;
			}
			_tmp35_ = base_method;
			self->priv->_base_method = _tmp35_;
			_tmp36_ = base_method;
			vala_code_node_copy_attribute_double ((ValaCodeNode*) self, (ValaCodeNode*) _tmp36_, "CCode", "instance_pos");
			_g_free0 (invalid_match);
			_vala_code_node_unref0 (base_method);
			_vala_code_node_unref0 (sym);
			return;
		}
		_vala_code_node_unref0 (base_method);
	}
	_tmp37_ = vala_class_get_base_class (cl);
	_tmp38_ = _tmp37_;
	if (_tmp38_ != NULL) {
		ValaClass* _tmp39_;
		ValaClass* _tmp40_;
		_tmp39_ = vala_class_get_base_class (cl);
		_tmp40_ = _tmp39_;
		vala_method_find_base_class_method (self, _tmp40_);
	}
	_vala_code_node_unref0 (sym);
}


static void
vala_method_find_base_interface_method (ValaMethod* self,
                                        ValaClass* cl)
{
	ValaDataType* _tmp84_;
	ValaDataType* _tmp85_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cl != NULL);
	{
		ValaList* _type_list = NULL;
		ValaList* _tmp0_;
		gint _type_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _type_index = 0;
		_tmp0_ = vala_class_get_base_types (cl);
		_type_list = _tmp0_;
		_tmp1_ = _type_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_type_size = _tmp3_;
		_type_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			ValaDataType* type = NULL;
			ValaList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_;
			ValaDataType* _tmp10_;
			ValaTypeSymbol* _tmp11_;
			ValaTypeSymbol* _tmp12_;
			_tmp4_ = _type_index;
			_type_index = _tmp4_ + 1;
			_tmp5_ = _type_index;
			_tmp6_ = _type_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _type_list;
			_tmp8_ = _type_index;
			_tmp9_ = vala_list_get (_tmp7_, _tmp8_);
			type = (ValaDataType*) _tmp9_;
			_tmp10_ = type;
			_tmp11_ = vala_data_type_get_data_type (_tmp10_);
			_tmp12_ = _tmp11_;
			if (VALA_IS_INTERFACE (_tmp12_)) {
				gboolean _tmp13_ = FALSE;
				ValaDataType* _tmp14_;
				ValaDataType* _tmp15_;
				ValaSymbol* sym = NULL;
				ValaDataType* _tmp23_;
				ValaTypeSymbol* _tmp24_;
				ValaTypeSymbol* _tmp25_;
				ValaScope* _tmp26_;
				ValaScope* _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				ValaSymbol* _tmp30_;
				ValaSymbol* _tmp31_;
				ValaSymbol* _tmp38_;
				_tmp14_ = vala_method_get_base_interface_type (self);
				_tmp15_ = _tmp14_;
				if (_tmp15_ != NULL) {
					ValaDataType* _tmp16_;
					ValaDataType* _tmp17_;
					ValaTypeSymbol* _tmp18_;
					ValaTypeSymbol* _tmp19_;
					ValaDataType* _tmp20_;
					ValaTypeSymbol* _tmp21_;
					ValaTypeSymbol* _tmp22_;
					_tmp16_ = vala_method_get_base_interface_type (self);
					_tmp17_ = _tmp16_;
					_tmp18_ = vala_data_type_get_data_type (_tmp17_);
					_tmp19_ = _tmp18_;
					_tmp20_ = type;
					_tmp21_ = vala_data_type_get_data_type (_tmp20_);
					_tmp22_ = _tmp21_;
					_tmp13_ = _tmp19_ != _tmp22_;
				} else {
					_tmp13_ = FALSE;
				}
				if (_tmp13_) {
					_vala_code_node_unref0 (type);
					continue;
				}
				_tmp23_ = type;
				_tmp24_ = vala_data_type_get_data_type (_tmp23_);
				_tmp25_ = _tmp24_;
				_tmp26_ = vala_symbol_get_scope ((ValaSymbol*) _tmp25_);
				_tmp27_ = _tmp26_;
				_tmp28_ = vala_symbol_get_name ((ValaSymbol*) self);
				_tmp29_ = _tmp28_;
				_tmp30_ = vala_scope_lookup (_tmp27_, _tmp29_);
				sym = _tmp30_;
				_tmp31_ = sym;
				if (VALA_IS_SIGNAL (_tmp31_)) {
					ValaSignal* sig = NULL;
					ValaSymbol* _tmp32_;
					ValaSignal* _tmp33_;
					ValaSignal* _tmp34_;
					ValaMethod* _tmp35_;
					ValaMethod* _tmp36_;
					ValaSymbol* _tmp37_;
					_tmp32_ = sym;
					_tmp33_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, VALA_TYPE_SIGNAL, ValaSignal));
					sig = _tmp33_;
					_tmp34_ = sig;
					_tmp35_ = vala_signal_get_default_handler (_tmp34_);
					_tmp36_ = _tmp35_;
					_tmp37_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp36_);
					_vala_code_node_unref0 (sym);
					sym = _tmp37_;
					_vala_code_node_unref0 (sig);
				}
				_tmp38_ = sym;
				if (VALA_IS_METHOD (_tmp38_)) {
					ValaMethod* base_method = NULL;
					ValaSymbol* _tmp39_;
					ValaMethod* _tmp40_;
					gboolean _tmp41_ = FALSE;
					ValaMethod* _tmp42_;
					gboolean _tmp43_;
					_tmp39_ = sym;
					_tmp40_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, VALA_TYPE_METHOD, ValaMethod));
					base_method = _tmp40_;
					_tmp42_ = base_method;
					_tmp43_ = _tmp42_->priv->_is_abstract;
					if (_tmp43_) {
						_tmp41_ = TRUE;
					} else {
						ValaMethod* _tmp44_;
						gboolean _tmp45_;
						_tmp44_ = base_method;
						_tmp45_ = _tmp44_->priv->_is_virtual;
						_tmp41_ = _tmp45_;
					}
					if (_tmp41_) {
						ValaDataType* _tmp46_;
						ValaDataType* _tmp47_;
						gchar* invalid_match = NULL;
						ValaMethod* _tmp67_;
						gchar* _tmp68_ = NULL;
						gboolean _tmp69_;
						ValaMethod* _tmp82_;
						ValaMethod* _tmp83_;
						_tmp46_ = vala_method_get_base_interface_type (self);
						_tmp47_ = _tmp46_;
						if (_tmp47_ == NULL) {
							gboolean has_explicit_implementation = FALSE;
							gboolean _tmp66_;
							has_explicit_implementation = FALSE;
							{
								ValaList* _m_list = NULL;
								ValaList* _tmp48_;
								gint _m_size = 0;
								ValaList* _tmp49_;
								gint _tmp50_;
								gint _tmp51_;
								gint _m_index = 0;
								_tmp48_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) cl);
								_m_list = _tmp48_;
								_tmp49_ = _m_list;
								_tmp50_ = vala_collection_get_size ((ValaCollection*) _tmp49_);
								_tmp51_ = _tmp50_;
								_m_size = _tmp51_;
								_m_index = -1;
								while (TRUE) {
									gint _tmp52_;
									gint _tmp53_;
									gint _tmp54_;
									ValaMethod* m = NULL;
									ValaList* _tmp55_;
									gint _tmp56_;
									gpointer _tmp57_;
									gboolean _tmp58_ = FALSE;
									ValaMethod* _tmp59_;
									ValaDataType* _tmp60_;
									ValaDataType* _tmp61_;
									_tmp52_ = _m_index;
									_m_index = _tmp52_ + 1;
									_tmp53_ = _m_index;
									_tmp54_ = _m_size;
									if (!(_tmp53_ < _tmp54_)) {
										break;
									}
									_tmp55_ = _m_list;
									_tmp56_ = _m_index;
									_tmp57_ = vala_list_get (_tmp55_, _tmp56_);
									m = (ValaMethod*) _tmp57_;
									_tmp59_ = m;
									_tmp60_ = vala_method_get_base_interface_type (_tmp59_);
									_tmp61_ = _tmp60_;
									if (_tmp61_ != NULL) {
										ValaMethod* _tmp62_;
										ValaMethod* _tmp63_;
										ValaMethod* _tmp64_;
										ValaMethod* _tmp65_;
										_tmp62_ = base_method;
										_tmp63_ = m;
										_tmp64_ = vala_method_get_base_interface_method (_tmp63_);
										_tmp65_ = _tmp64_;
										_tmp58_ = _tmp62_ == _tmp65_;
									} else {
										_tmp58_ = FALSE;
									}
									if (_tmp58_) {
										has_explicit_implementation = TRUE;
										_vala_code_node_unref0 (m);
										break;
									}
									_vala_code_node_unref0 (m);
								}
								_vala_iterable_unref0 (_m_list);
							}
							_tmp66_ = has_explicit_implementation;
							if (_tmp66_) {
								_vala_code_node_unref0 (base_method);
								_vala_code_node_unref0 (sym);
								_vala_code_node_unref0 (type);
								continue;
							}
						}
						invalid_match = NULL;
						_tmp67_ = base_method;
						_tmp69_ = vala_method_compatible (self, _tmp67_, &_tmp68_);
						_g_free0 (invalid_match);
						invalid_match = _tmp68_;
						if (!_tmp69_) {
							ValaMethodType* base_method_type = NULL;
							ValaMethod* _tmp70_;
							ValaMethodType* _tmp71_;
							ValaSourceReference* _tmp72_;
							ValaSourceReference* _tmp73_;
							gchar* _tmp74_;
							gchar* _tmp75_;
							ValaMethodType* _tmp76_;
							gchar* _tmp77_;
							gchar* _tmp78_;
							const gchar* _tmp79_;
							gchar* _tmp80_;
							gchar* _tmp81_;
							vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
							_tmp70_ = base_method;
							_tmp71_ = vala_method_type_new (_tmp70_);
							base_method_type = _tmp71_;
							_tmp72_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
							_tmp73_ = _tmp72_;
							_tmp74_ = vala_symbol_get_full_name ((ValaSymbol*) self);
							_tmp75_ = _tmp74_;
							_tmp76_ = base_method_type;
							_tmp77_ = vala_data_type_to_prototype_string ((ValaDataType*) _tmp76_, NULL);
							_tmp78_ = _tmp77_;
							_tmp79_ = invalid_match;
							_tmp80_ = g_strdup_printf ("overriding method `%s' is incompatible with base method `%s': %s.", _tmp75_, _tmp78_, _tmp79_);
							_tmp81_ = _tmp80_;
							vala_report_error (_tmp73_, _tmp81_);
							_g_free0 (_tmp81_);
							_g_free0 (_tmp78_);
							_g_free0 (_tmp75_);
							_vala_code_node_unref0 (base_method_type);
							_g_free0 (invalid_match);
							_vala_code_node_unref0 (base_method);
							_vala_code_node_unref0 (sym);
							_vala_code_node_unref0 (type);
							_vala_iterable_unref0 (_type_list);
							return;
						}
						_tmp82_ = base_method;
						self->priv->_base_interface_method = _tmp82_;
						_tmp83_ = base_method;
						vala_code_node_copy_attribute_double ((ValaCodeNode*) self, (ValaCodeNode*) _tmp83_, "CCode", "instance_pos");
						_g_free0 (invalid_match);
						_vala_code_node_unref0 (base_method);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						_vala_iterable_unref0 (_type_list);
						return;
					}
					_vala_code_node_unref0 (base_method);
				}
				_vala_code_node_unref0 (sym);
			}
			_vala_code_node_unref0 (type);
		}
		_vala_iterable_unref0 (_type_list);
	}
	_tmp84_ = vala_method_get_base_interface_type (self);
	_tmp85_ = _tmp84_;
	if (_tmp85_ != NULL) {
		ValaSourceReference* _tmp86_;
		ValaSourceReference* _tmp87_;
		gchar* _tmp88_;
		gchar* _tmp89_;
		gchar* _tmp90_;
		gchar* _tmp91_;
		_tmp86_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp87_ = _tmp86_;
		_tmp88_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp89_ = _tmp88_;
		_tmp90_ = g_strdup_printf ("`%s': no suitable interface method found to implement", _tmp89_);
		_tmp91_ = _tmp90_;
		vala_report_error (_tmp87_, _tmp91_);
		_g_free0 (_tmp91_);
		_g_free0 (_tmp89_);
	}
}


static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}


static gboolean
vala_method_real_check (ValaCodeNode* base,
                        ValaCodeContext* context)
{
	ValaMethod * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaAttribute* _tmp4_;
	ValaAttribute* _tmp5_;
	gboolean _tmp6_;
	ValaAttribute* _tmp10_;
	ValaAttribute* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp15_ = FALSE;
	ValaSymbol* _tmp16_;
	ValaSymbol* _tmp17_;
	gboolean _tmp33_;
	gboolean _tmp70_ = FALSE;
	gboolean _tmp71_;
	gboolean _tmp111_ = FALSE;
	gboolean _tmp112_ = FALSE;
	gboolean _tmp113_;
	ValaSourceFile* old_source_file = NULL;
	ValaSemanticAnalyzer* _tmp118_;
	ValaSemanticAnalyzer* _tmp119_;
	ValaSourceFile* _tmp120_;
	ValaSourceFile* _tmp121_;
	ValaSourceFile* _tmp122_;
	ValaSymbol* old_symbol = NULL;
	ValaSemanticAnalyzer* _tmp123_;
	ValaSemanticAnalyzer* _tmp124_;
	ValaSymbol* _tmp125_;
	ValaSymbol* _tmp126_;
	ValaSymbol* _tmp127_;
	ValaSourceReference* _tmp128_;
	ValaSourceReference* _tmp129_;
	ValaSemanticAnalyzer* _tmp136_;
	ValaSemanticAnalyzer* _tmp137_;
	ValaDataType* _tmp138_;
	ValaDataType* _tmp139_;
	ValaDataType* _tmp140_;
	ValaDataType* _tmp141_;
	ValaTypeSymbol* _tmp142_;
	ValaTypeSymbol* _tmp143_;
	ValaSemanticAnalyzer* _tmp144_;
	ValaSemanticAnalyzer* _tmp145_;
	ValaDataType* _tmp146_;
	ValaTypeSymbol* _tmp147_;
	ValaTypeSymbol* _tmp148_;
	ValaAttribute* init_attr = NULL;
	ValaAttribute* _tmp159_;
	ValaAttribute* _tmp160_;
	ValaDataType* _tmp167_;
	ValaDataType* _tmp168_;
	gboolean _tmp171_ = FALSE;
	gboolean _tmp172_ = FALSE;
	gboolean _tmp173_ = FALSE;
	ValaList* _tmp174_;
	gint _tmp175_;
	gint _tmp176_;
	gboolean _tmp190_ = FALSE;
	ValaAttribute* _tmp191_;
	ValaAttribute* _tmp192_;
	gboolean _tmp193_;
	gboolean optional_param = FALSE;
	ValaLocalVariable* _tmp293_;
	ValaLocalVariable* _tmp294_;
	ValaList* _tmp297_;
	ValaList* _tmp310_;
	ValaBlock* _tmp323_;
	ValaBlock* _tmp324_;
	ValaSemanticAnalyzer* _tmp327_;
	ValaSemanticAnalyzer* _tmp328_;
	ValaStruct* _tmp329_;
	ValaStruct* _tmp330_;
	gboolean _tmp366_ = FALSE;
	gboolean _tmp367_ = FALSE;
	ValaDataType* _tmp368_;
	ValaDataType* _tmp369_;
	ValaSemanticAnalyzer* _tmp417_;
	ValaSemanticAnalyzer* _tmp418_;
	ValaSourceFile* _tmp419_;
	ValaSemanticAnalyzer* _tmp420_;
	ValaSemanticAnalyzer* _tmp421_;
	ValaSymbol* _tmp422_;
	gboolean _tmp423_ = FALSE;
	gboolean _tmp424_ = FALSE;
	gboolean _tmp425_ = FALSE;
	gboolean _tmp426_;
	gboolean _tmp427_;
	ValaSemanticAnalyzer* _tmp443_;
	ValaSemanticAnalyzer* _tmp444_;
	ValaDataType* _tmp445_;
	ValaDataType* _tmp446_;
	gboolean _tmp501_ = FALSE;
	ValaBlock* _tmp502_;
	ValaBlock* _tmp503_;
	gboolean _tmp548_ = FALSE;
	gboolean _tmp549_ = FALSE;
	gboolean _tmp550_ = FALSE;
	gboolean _tmp551_ = FALSE;
	gboolean _tmp552_ = FALSE;
	ValaAttribute* _tmp613_;
	ValaAttribute* _tmp614_;
	gboolean _tmp615_;
	gboolean _tmp616_;
	gboolean _tmp617_;
	self = (ValaMethod*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "DestroysInstance");
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_ != NULL;
	_vala_code_node_unref0 (_tmp5_);
	if (_tmp6_) {
		ValaParameter* _tmp7_;
		ValaDataType* _tmp8_;
		ValaDataType* _tmp9_;
		_tmp7_ = self->priv->_this_parameter;
		_tmp8_ = vala_variable_get_variable_type ((ValaVariable*) _tmp7_);
		_tmp9_ = _tmp8_;
		vala_data_type_set_value_owned (_tmp9_, TRUE);
	}
	_tmp10_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "NoThrow");
	_tmp11_ = _tmp10_;
	_tmp12_ = _tmp11_ != NULL;
	_vala_code_node_unref0 (_tmp11_);
	if (_tmp12_) {
		ValaList* _tmp13_;
		ValaList* _tmp14_;
		_tmp13_ = vala_code_node_get_error_types ((ValaCodeNode*) self);
		_tmp14_ = _tmp13_;
		vala_collection_clear ((ValaCollection*) _tmp14_);
		_vala_iterable_unref0 (_tmp14_);
	}
	_tmp16_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp17_ = _tmp16_;
	if (VALA_IS_CLASS (_tmp17_)) {
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_;
		_tmp19_ = self->priv->_is_abstract;
		if (_tmp19_) {
			_tmp18_ = TRUE;
		} else {
			gboolean _tmp20_;
			_tmp20_ = self->priv->_is_virtual;
			_tmp18_ = _tmp20_;
		}
		_tmp15_ = _tmp18_;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		ValaClass* cl = NULL;
		ValaSymbol* _tmp21_;
		ValaSymbol* _tmp22_;
		ValaClass* _tmp23_;
		gboolean _tmp24_ = FALSE;
		ValaClass* _tmp25_;
		gboolean _tmp26_;
		gboolean _tmp27_;
		_tmp21_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp22_ = _tmp21_;
		_tmp23_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, VALA_TYPE_CLASS, ValaClass));
		cl = _tmp23_;
		_tmp25_ = cl;
		_tmp26_ = vala_class_get_is_compact (_tmp25_);
		_tmp27_ = _tmp26_;
		if (_tmp27_) {
			ValaClass* _tmp28_;
			ValaClass* _tmp29_;
			ValaClass* _tmp30_;
			_tmp28_ = cl;
			_tmp29_ = vala_class_get_base_class (_tmp28_);
			_tmp30_ = _tmp29_;
			_tmp24_ = _tmp30_ != NULL;
		} else {
			_tmp24_ = FALSE;
		}
		if (_tmp24_) {
			ValaSourceReference* _tmp31_;
			ValaSourceReference* _tmp32_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp31_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp32_ = _tmp31_;
			vala_report_error (_tmp32_, "Abstract and virtual methods may not be declared in derived compact cl" \
"asses");
			result = FALSE;
			_vala_code_node_unref0 (cl);
			return result;
		}
		_vala_code_node_unref0 (cl);
	}
	_tmp33_ = self->priv->_is_abstract;
	if (_tmp33_) {
		ValaSymbol* _tmp34_;
		ValaSymbol* _tmp35_;
		_tmp34_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp35_ = _tmp34_;
		if (VALA_IS_CLASS (_tmp35_)) {
			ValaClass* cl = NULL;
			ValaSymbol* _tmp36_;
			ValaSymbol* _tmp37_;
			ValaClass* _tmp38_;
			ValaClass* _tmp39_;
			gboolean _tmp40_;
			gboolean _tmp41_;
			_tmp36_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp37_ = _tmp36_;
			_tmp38_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, VALA_TYPE_CLASS, ValaClass));
			cl = _tmp38_;
			_tmp39_ = cl;
			_tmp40_ = vala_class_get_is_abstract (_tmp39_);
			_tmp41_ = _tmp40_;
			if (!_tmp41_) {
				ValaSourceReference* _tmp42_;
				ValaSourceReference* _tmp43_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp42_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp43_ = _tmp42_;
				vala_report_error (_tmp43_, "Abstract methods may not be declared in non-abstract classes");
				result = FALSE;
				_vala_code_node_unref0 (cl);
				return result;
			}
			_vala_code_node_unref0 (cl);
		} else {
			ValaSymbol* _tmp44_;
			ValaSymbol* _tmp45_;
			_tmp44_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp45_ = _tmp44_;
			if (!VALA_IS_INTERFACE (_tmp45_)) {
				ValaSourceReference* _tmp46_;
				ValaSourceReference* _tmp47_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp46_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp47_ = _tmp46_;
				vala_report_error (_tmp47_, "Abstract methods may not be declared outside of classes and interfaces");
				result = FALSE;
				return result;
			}
		}
	} else {
		gboolean _tmp48_;
		_tmp48_ = self->priv->_is_virtual;
		if (_tmp48_) {
			gboolean _tmp49_ = FALSE;
			ValaSymbol* _tmp50_;
			ValaSymbol* _tmp51_;
			_tmp50_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp51_ = _tmp50_;
			if (!VALA_IS_CLASS (_tmp51_)) {
				ValaSymbol* _tmp52_;
				ValaSymbol* _tmp53_;
				_tmp52_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
				_tmp53_ = _tmp52_;
				_tmp49_ = !VALA_IS_INTERFACE (_tmp53_);
			} else {
				_tmp49_ = FALSE;
			}
			if (_tmp49_) {
				ValaSourceReference* _tmp54_;
				ValaSourceReference* _tmp55_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp54_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp55_ = _tmp54_;
				vala_report_error (_tmp55_, "Virtual methods may not be declared outside of classes and interfaces");
				result = FALSE;
				return result;
			}
		} else {
			gboolean _tmp56_;
			_tmp56_ = self->priv->_overrides;
			if (_tmp56_) {
				ValaSymbol* _tmp57_;
				ValaSymbol* _tmp58_;
				_tmp57_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
				_tmp58_ = _tmp57_;
				if (!VALA_IS_CLASS (_tmp58_)) {
					ValaSourceReference* _tmp59_;
					ValaSourceReference* _tmp60_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp59_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp60_ = _tmp59_;
					vala_report_error (_tmp60_, "Methods may not be overridden outside of classes");
					result = FALSE;
					return result;
				}
			} else {
				ValaSymbolAccessibility _tmp61_;
				ValaSymbolAccessibility _tmp62_;
				_tmp61_ = vala_symbol_get_access ((ValaSymbol*) self);
				_tmp62_ = _tmp61_;
				if (_tmp62_ == VALA_SYMBOL_ACCESSIBILITY_PROTECTED) {
					gboolean _tmp63_ = FALSE;
					ValaSymbol* _tmp64_;
					ValaSymbol* _tmp65_;
					_tmp64_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
					_tmp65_ = _tmp64_;
					if (!VALA_IS_CLASS (_tmp65_)) {
						ValaSymbol* _tmp66_;
						ValaSymbol* _tmp67_;
						_tmp66_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
						_tmp67_ = _tmp66_;
						_tmp63_ = !VALA_IS_INTERFACE (_tmp67_);
					} else {
						_tmp63_ = FALSE;
					}
					if (_tmp63_) {
						ValaSourceReference* _tmp68_;
						ValaSourceReference* _tmp69_;
						vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
						_tmp68_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
						_tmp69_ = _tmp68_;
						vala_report_error (_tmp69_, "Protected methods may not be declared outside of classes and interface" \
"s");
						result = FALSE;
						return result;
					}
				}
			}
		}
	}
	_tmp71_ = self->priv->_is_abstract;
	if (_tmp71_) {
		ValaBlock* _tmp72_;
		ValaBlock* _tmp73_;
		_tmp72_ = vala_subroutine_get_body ((ValaSubroutine*) self);
		_tmp73_ = _tmp72_;
		_tmp70_ = _tmp73_ != NULL;
	} else {
		_tmp70_ = FALSE;
	}
	if (_tmp70_) {
		ValaSourceReference* _tmp74_;
		ValaSourceReference* _tmp75_;
		_tmp74_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp75_ = _tmp74_;
		vala_report_error (_tmp75_, "Abstract methods cannot have bodies");
	} else {
		gboolean _tmp76_ = FALSE;
		gboolean _tmp77_ = FALSE;
		gboolean _tmp78_ = FALSE;
		gboolean _tmp79_ = FALSE;
		gboolean _tmp80_;
		_tmp80_ = self->priv->_is_abstract;
		if (_tmp80_) {
			_tmp79_ = TRUE;
		} else {
			gboolean _tmp81_;
			_tmp81_ = self->priv->_is_virtual;
			_tmp79_ = _tmp81_;
		}
		if (_tmp79_) {
			gboolean _tmp82_;
			gboolean _tmp83_;
			_tmp82_ = vala_symbol_get_external ((ValaSymbol*) self);
			_tmp83_ = _tmp82_;
			_tmp78_ = _tmp83_;
		} else {
			_tmp78_ = FALSE;
		}
		if (_tmp78_) {
			gboolean _tmp84_;
			gboolean _tmp85_;
			_tmp84_ = vala_symbol_get_external_package ((ValaSymbol*) self);
			_tmp85_ = _tmp84_;
			_tmp77_ = !_tmp85_;
		} else {
			_tmp77_ = FALSE;
		}
		if (_tmp77_) {
			ValaSymbol* _tmp86_;
			ValaSymbol* _tmp87_;
			gboolean _tmp88_;
			gboolean _tmp89_;
			_tmp86_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp87_ = _tmp86_;
			_tmp88_ = vala_symbol_get_external (_tmp87_);
			_tmp89_ = _tmp88_;
			_tmp76_ = !_tmp89_;
		} else {
			_tmp76_ = FALSE;
		}
		if (_tmp76_) {
			ValaSourceReference* _tmp90_;
			ValaSourceReference* _tmp91_;
			_tmp90_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp91_ = _tmp90_;
			vala_report_error (_tmp91_, "Extern methods cannot be abstract or virtual");
		} else {
			gboolean _tmp92_ = FALSE;
			gboolean _tmp93_;
			gboolean _tmp94_;
			_tmp93_ = vala_symbol_get_external ((ValaSymbol*) self);
			_tmp94_ = _tmp93_;
			if (_tmp94_) {
				ValaBlock* _tmp95_;
				ValaBlock* _tmp96_;
				_tmp95_ = vala_subroutine_get_body ((ValaSubroutine*) self);
				_tmp96_ = _tmp95_;
				_tmp92_ = _tmp96_ != NULL;
			} else {
				_tmp92_ = FALSE;
			}
			if (_tmp92_) {
				ValaSourceReference* _tmp97_;
				ValaSourceReference* _tmp98_;
				_tmp97_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp98_ = _tmp97_;
				vala_report_error (_tmp98_, "Extern methods cannot have bodies");
			} else {
				gboolean _tmp99_ = FALSE;
				gboolean _tmp100_ = FALSE;
				gboolean _tmp101_ = FALSE;
				gboolean _tmp102_;
				_tmp102_ = self->priv->_is_abstract;
				if (!_tmp102_) {
					gboolean _tmp103_;
					gboolean _tmp104_;
					_tmp103_ = vala_symbol_get_external ((ValaSymbol*) self);
					_tmp104_ = _tmp103_;
					_tmp101_ = !_tmp104_;
				} else {
					_tmp101_ = FALSE;
				}
				if (_tmp101_) {
					ValaSourceFileType _tmp105_;
					ValaSourceFileType _tmp106_;
					_tmp105_ = vala_symbol_get_source_type ((ValaSymbol*) self);
					_tmp106_ = _tmp105_;
					_tmp100_ = _tmp106_ == VALA_SOURCE_FILE_TYPE_SOURCE;
				} else {
					_tmp100_ = FALSE;
				}
				if (_tmp100_) {
					ValaBlock* _tmp107_;
					ValaBlock* _tmp108_;
					_tmp107_ = vala_subroutine_get_body ((ValaSubroutine*) self);
					_tmp108_ = _tmp107_;
					_tmp99_ = _tmp108_ == NULL;
				} else {
					_tmp99_ = FALSE;
				}
				if (_tmp99_) {
					ValaSourceReference* _tmp109_;
					ValaSourceReference* _tmp110_;
					_tmp109_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp110_ = _tmp109_;
					vala_report_error (_tmp110_, "Non-abstract, non-extern methods must have bodies");
				}
			}
		}
	}
	_tmp113_ = self->priv->_coroutine;
	if (_tmp113_) {
		gboolean _tmp114_;
		gboolean _tmp115_;
		_tmp114_ = vala_symbol_get_external_package ((ValaSymbol*) self);
		_tmp115_ = _tmp114_;
		_tmp112_ = !_tmp115_;
	} else {
		_tmp112_ = FALSE;
	}
	if (_tmp112_) {
		_tmp111_ = !vala_code_context_has_package (context, "gio-2.0");
	} else {
		_tmp111_ = FALSE;
	}
	if (_tmp111_) {
		ValaSourceReference* _tmp116_;
		ValaSourceReference* _tmp117_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp116_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp117_ = _tmp116_;
		vala_report_error (_tmp117_, "gio-2.0 package required for async methods");
		result = FALSE;
		return result;
	}
	_tmp118_ = vala_code_context_get_analyzer (context);
	_tmp119_ = _tmp118_;
	_tmp120_ = vala_semantic_analyzer_get_current_source_file (_tmp119_);
	_tmp121_ = _tmp120_;
	_tmp122_ = _vala_source_file_ref0 (_tmp121_);
	old_source_file = _tmp122_;
	_tmp123_ = vala_code_context_get_analyzer (context);
	_tmp124_ = _tmp123_;
	_tmp125_ = vala_semantic_analyzer_get_current_symbol (_tmp124_);
	_tmp126_ = _tmp125_;
	_tmp127_ = _vala_code_node_ref0 (_tmp126_);
	old_symbol = _tmp127_;
	_tmp128_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
	_tmp129_ = _tmp128_;
	if (_tmp129_ != NULL) {
		ValaSemanticAnalyzer* _tmp130_;
		ValaSemanticAnalyzer* _tmp131_;
		ValaSourceReference* _tmp132_;
		ValaSourceReference* _tmp133_;
		ValaSourceFile* _tmp134_;
		ValaSourceFile* _tmp135_;
		_tmp130_ = vala_code_context_get_analyzer (context);
		_tmp131_ = _tmp130_;
		_tmp132_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp133_ = _tmp132_;
		_tmp134_ = vala_source_reference_get_file (_tmp133_);
		_tmp135_ = _tmp134_;
		vala_semantic_analyzer_set_current_source_file (_tmp131_, _tmp135_);
	}
	_tmp136_ = vala_code_context_get_analyzer (context);
	_tmp137_ = _tmp136_;
	vala_semantic_analyzer_set_current_symbol (_tmp137_, (ValaSymbol*) self);
	_tmp138_ = vala_callable_get_return_type ((ValaCallable*) self);
	_tmp139_ = _tmp138_;
	vala_code_node_check ((ValaCodeNode*) _tmp139_, context);
	_tmp140_ = vala_callable_get_return_type ((ValaCallable*) self);
	_tmp141_ = _tmp140_;
	_tmp142_ = vala_data_type_get_data_type (_tmp141_);
	_tmp143_ = _tmp142_;
	_tmp144_ = vala_code_context_get_analyzer (context);
	_tmp145_ = _tmp144_;
	_tmp146_ = _tmp145_->va_list_type;
	_tmp147_ = vala_data_type_get_data_type (_tmp146_);
	_tmp148_ = _tmp147_;
	if (_tmp143_ == _tmp148_) {
		ValaSourceReference* _tmp149_;
		ValaSourceReference* _tmp150_;
		ValaDataType* _tmp151_;
		ValaDataType* _tmp152_;
		ValaTypeSymbol* _tmp153_;
		ValaTypeSymbol* _tmp154_;
		gchar* _tmp155_;
		gchar* _tmp156_;
		gchar* _tmp157_;
		gchar* _tmp158_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp149_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp150_ = _tmp149_;
		_tmp151_ = vala_callable_get_return_type ((ValaCallable*) self);
		_tmp152_ = _tmp151_;
		_tmp153_ = vala_data_type_get_data_type (_tmp152_);
		_tmp154_ = _tmp153_;
		_tmp155_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp154_);
		_tmp156_ = _tmp155_;
		_tmp157_ = g_strdup_printf ("`%s' not supported as return type", _tmp156_);
		_tmp158_ = _tmp157_;
		vala_report_error (_tmp150_, _tmp158_);
		_g_free0 (_tmp158_);
		_g_free0 (_tmp156_);
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	_tmp159_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "ModuleInit");
	init_attr = _tmp159_;
	_tmp160_ = init_attr;
	if (_tmp160_ != NULL) {
		ValaSourceReference* _tmp161_;
		ValaSourceReference* _tmp162_;
		ValaSourceFile* _tmp163_;
		ValaSourceFile* _tmp164_;
		ValaCodeContext* _tmp165_;
		ValaCodeContext* _tmp166_;
		_tmp161_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp162_ = _tmp161_;
		_tmp163_ = vala_source_reference_get_file (_tmp162_);
		_tmp164_ = _tmp163_;
		_tmp165_ = vala_source_file_get_context (_tmp164_);
		_tmp166_ = _tmp165_;
		vala_code_context_set_module_init_method (_tmp166_, self);
	}
	_tmp167_ = vala_callable_get_return_type ((ValaCallable*) self);
	_tmp168_ = _tmp167_;
	if (_tmp168_ != NULL) {
		ValaDataType* _tmp169_;
		ValaDataType* _tmp170_;
		_tmp169_ = vala_callable_get_return_type ((ValaCallable*) self);
		_tmp170_ = _tmp169_;
		vala_code_node_check ((ValaCodeNode*) _tmp170_, context);
	}
	_tmp174_ = self->priv->parameters;
	_tmp175_ = vala_collection_get_size ((ValaCollection*) _tmp174_);
	_tmp176_ = _tmp175_;
	if (_tmp176_ == 1) {
		ValaList* _tmp177_;
		gpointer _tmp178_;
		ValaParameter* _tmp179_;
		gboolean _tmp180_;
		gboolean _tmp181_;
		_tmp177_ = self->priv->parameters;
		_tmp178_ = vala_list_get (_tmp177_, 0);
		_tmp179_ = (ValaParameter*) _tmp178_;
		_tmp180_ = vala_parameter_get_ellipsis (_tmp179_);
		_tmp181_ = _tmp180_;
		_tmp173_ = _tmp181_;
		_vala_code_node_unref0 (_tmp179_);
	} else {
		_tmp173_ = FALSE;
	}
	if (_tmp173_) {
		ValaBlock* _tmp182_;
		ValaBlock* _tmp183_;
		_tmp182_ = vala_subroutine_get_body ((ValaSubroutine*) self);
		_tmp183_ = _tmp182_;
		_tmp172_ = _tmp183_ != NULL;
	} else {
		_tmp172_ = FALSE;
	}
	if (_tmp172_) {
		ValaMemberBinding _tmp184_;
		_tmp184_ = self->priv->_binding;
		_tmp171_ = _tmp184_ != VALA_MEMBER_BINDING_INSTANCE;
	} else {
		_tmp171_ = FALSE;
	}
	if (_tmp171_) {
		ValaList* _tmp185_;
		gpointer _tmp186_;
		ValaParameter* _tmp187_;
		ValaSourceReference* _tmp188_;
		ValaSourceReference* _tmp189_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp185_ = self->priv->parameters;
		_tmp186_ = vala_list_get (_tmp185_, 0);
		_tmp187_ = (ValaParameter*) _tmp186_;
		_tmp188_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp187_);
		_tmp189_ = _tmp188_;
		vala_report_error (_tmp189_, "Named parameter required before `...'");
		_vala_code_node_unref0 (_tmp187_);
	}
	_tmp191_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "Print");
	_tmp192_ = _tmp191_;
	_tmp193_ = _tmp192_ != NULL;
	_vala_code_node_unref0 (_tmp192_);
	if (_tmp193_) {
		gboolean _tmp194_ = FALSE;
		ValaList* _tmp195_;
		gint _tmp196_;
		gint _tmp197_;
		_tmp195_ = self->priv->parameters;
		_tmp196_ = vala_collection_get_size ((ValaCollection*) _tmp195_);
		_tmp197_ = _tmp196_;
		if (_tmp197_ != 1) {
			_tmp194_ = TRUE;
		} else {
			ValaList* _tmp198_;
			gpointer _tmp199_;
			ValaParameter* _tmp200_;
			ValaDataType* _tmp201_;
			ValaDataType* _tmp202_;
			ValaTypeSymbol* _tmp203_;
			ValaTypeSymbol* _tmp204_;
			ValaSemanticAnalyzer* _tmp205_;
			ValaSemanticAnalyzer* _tmp206_;
			ValaDataType* _tmp207_;
			ValaTypeSymbol* _tmp208_;
			ValaTypeSymbol* _tmp209_;
			_tmp198_ = self->priv->parameters;
			_tmp199_ = vala_list_get (_tmp198_, 0);
			_tmp200_ = (ValaParameter*) _tmp199_;
			_tmp201_ = vala_variable_get_variable_type ((ValaVariable*) _tmp200_);
			_tmp202_ = _tmp201_;
			_tmp203_ = vala_data_type_get_data_type (_tmp202_);
			_tmp204_ = _tmp203_;
			_tmp205_ = vala_code_context_get_analyzer (context);
			_tmp206_ = _tmp205_;
			_tmp207_ = _tmp206_->string_type;
			_tmp208_ = vala_data_type_get_data_type (_tmp207_);
			_tmp209_ = _tmp208_;
			_tmp194_ = _tmp204_ != _tmp209_;
			_vala_code_node_unref0 (_tmp200_);
		}
		_tmp190_ = _tmp194_;
	} else {
		_tmp190_ = FALSE;
	}
	if (_tmp190_) {
		ValaSourceReference* _tmp210_;
		ValaSourceReference* _tmp211_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp210_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp211_ = _tmp210_;
		vala_report_error (_tmp211_, "[Print] methods must have exactly one parameter of type `string'");
	}
	optional_param = FALSE;
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp212_;
		ValaList* _tmp213_;
		gint _param_size = 0;
		ValaList* _tmp214_;
		gint _tmp215_;
		gint _tmp216_;
		gint _param_index = 0;
		_tmp212_ = self->priv->parameters;
		_tmp213_ = _vala_iterable_ref0 (_tmp212_);
		_param_list = _tmp213_;
		_tmp214_ = _param_list;
		_tmp215_ = vala_collection_get_size ((ValaCollection*) _tmp214_);
		_tmp216_ = _tmp215_;
		_param_size = _tmp216_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp217_;
			gint _tmp218_;
			gint _tmp219_;
			ValaParameter* param = NULL;
			ValaList* _tmp220_;
			gint _tmp221_;
			gpointer _tmp222_;
			ValaParameter* _tmp223_;
			gboolean _tmp224_ = FALSE;
			gboolean _tmp225_;
			gboolean _tmp232_ = FALSE;
			gboolean _tmp233_ = FALSE;
			gboolean _tmp234_;
			gboolean _tmp235_;
			gboolean _tmp254_;
			gboolean _tmp255_ = FALSE;
			gboolean _tmp256_ = FALSE;
			gboolean _tmp257_;
			_tmp217_ = _param_index;
			_param_index = _tmp217_ + 1;
			_tmp218_ = _param_index;
			_tmp219_ = _param_size;
			if (!(_tmp218_ < _tmp219_)) {
				break;
			}
			_tmp220_ = _param_list;
			_tmp221_ = _param_index;
			_tmp222_ = vala_list_get (_tmp220_, _tmp221_);
			param = (ValaParameter*) _tmp222_;
			_tmp223_ = param;
			if (!vala_code_node_check ((ValaCodeNode*) _tmp223_, context)) {
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_vala_code_node_unref0 (param);
				continue;
			}
			_tmp225_ = self->priv->_coroutine;
			if (_tmp225_) {
				ValaParameter* _tmp226_;
				ValaParameterDirection _tmp227_;
				ValaParameterDirection _tmp228_;
				_tmp226_ = param;
				_tmp227_ = vala_parameter_get_direction (_tmp226_);
				_tmp228_ = _tmp227_;
				_tmp224_ = _tmp228_ == VALA_PARAMETER_DIRECTION_REF;
			} else {
				_tmp224_ = FALSE;
			}
			if (_tmp224_) {
				ValaParameter* _tmp229_;
				ValaSourceReference* _tmp230_;
				ValaSourceReference* _tmp231_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp229_ = param;
				_tmp230_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp229_);
				_tmp231_ = _tmp230_;
				vala_report_error (_tmp231_, "Reference parameters are not supported for async methods");
			}
			_tmp234_ = vala_symbol_get_external_package ((ValaSymbol*) self);
			_tmp235_ = _tmp234_;
			if (!_tmp235_) {
				gboolean _tmp236_;
				_tmp236_ = self->priv->_coroutine;
				_tmp233_ = _tmp236_;
			} else {
				_tmp233_ = FALSE;
			}
			if (_tmp233_) {
				gboolean _tmp237_ = FALSE;
				ValaParameter* _tmp238_;
				gboolean _tmp239_;
				gboolean _tmp240_;
				_tmp238_ = param;
				_tmp239_ = vala_parameter_get_ellipsis (_tmp238_);
				_tmp240_ = _tmp239_;
				if (_tmp240_) {
					_tmp237_ = TRUE;
				} else {
					ValaParameter* _tmp241_;
					ValaDataType* _tmp242_;
					ValaDataType* _tmp243_;
					ValaTypeSymbol* _tmp244_;
					ValaTypeSymbol* _tmp245_;
					ValaSemanticAnalyzer* _tmp246_;
					ValaSemanticAnalyzer* _tmp247_;
					ValaDataType* _tmp248_;
					ValaTypeSymbol* _tmp249_;
					ValaTypeSymbol* _tmp250_;
					_tmp241_ = param;
					_tmp242_ = vala_variable_get_variable_type ((ValaVariable*) _tmp241_);
					_tmp243_ = _tmp242_;
					_tmp244_ = vala_data_type_get_data_type (_tmp243_);
					_tmp245_ = _tmp244_;
					_tmp246_ = vala_code_context_get_analyzer (context);
					_tmp247_ = _tmp246_;
					_tmp248_ = _tmp247_->va_list_type;
					_tmp249_ = vala_data_type_get_data_type (_tmp248_);
					_tmp250_ = _tmp249_;
					_tmp237_ = _tmp245_ == _tmp250_;
				}
				_tmp232_ = _tmp237_;
			} else {
				_tmp232_ = FALSE;
			}
			if (_tmp232_) {
				ValaParameter* _tmp251_;
				ValaSourceReference* _tmp252_;
				ValaSourceReference* _tmp253_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp251_ = param;
				_tmp252_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp251_);
				_tmp253_ = _tmp252_;
				vala_report_error (_tmp253_, "Variadic parameters are not supported for async methods");
				result = FALSE;
				_vala_code_node_unref0 (param);
				_vala_iterable_unref0 (_param_list);
				_vala_code_node_unref0 (init_attr);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_tmp254_ = self->priv->_coroutine;
			if (_tmp254_) {
				_vala_code_node_unref0 (param);
				continue;
			}
			_tmp257_ = optional_param;
			if (_tmp257_) {
				ValaParameter* _tmp258_;
				ValaExpression* _tmp259_;
				ValaExpression* _tmp260_;
				_tmp258_ = param;
				_tmp259_ = vala_variable_get_initializer ((ValaVariable*) _tmp258_);
				_tmp260_ = _tmp259_;
				_tmp256_ = _tmp260_ == NULL;
			} else {
				_tmp256_ = FALSE;
			}
			if (_tmp256_) {
				ValaParameter* _tmp261_;
				gboolean _tmp262_;
				gboolean _tmp263_;
				_tmp261_ = param;
				_tmp262_ = vala_parameter_get_ellipsis (_tmp261_);
				_tmp263_ = _tmp262_;
				_tmp255_ = !_tmp263_;
			} else {
				_tmp255_ = FALSE;
			}
			if (_tmp255_) {
				ValaParameter* _tmp264_;
				ValaSourceReference* _tmp265_;
				ValaSourceReference* _tmp266_;
				_tmp264_ = param;
				_tmp265_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp264_);
				_tmp266_ = _tmp265_;
				vala_report_warning (_tmp266_, "parameter without default follows parameter with default");
			} else {
				ValaParameter* _tmp267_;
				ValaExpression* _tmp268_;
				ValaExpression* _tmp269_;
				_tmp267_ = param;
				_tmp268_ = vala_variable_get_initializer ((ValaVariable*) _tmp267_);
				_tmp269_ = _tmp268_;
				if (_tmp269_ != NULL) {
					optional_param = TRUE;
				}
			}
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	{
		ValaList* _error_type_list = NULL;
		ValaList* _tmp270_;
		gint _error_type_size = 0;
		ValaList* _tmp271_;
		gint _tmp272_;
		gint _tmp273_;
		gint _error_type_index = 0;
		_tmp270_ = vala_code_node_get_error_types ((ValaCodeNode*) self);
		_error_type_list = _tmp270_;
		_tmp271_ = _error_type_list;
		_tmp272_ = vala_collection_get_size ((ValaCollection*) _tmp271_);
		_tmp273_ = _tmp272_;
		_error_type_size = _tmp273_;
		_error_type_index = -1;
		while (TRUE) {
			gint _tmp274_;
			gint _tmp275_;
			gint _tmp276_;
			ValaDataType* error_type = NULL;
			ValaList* _tmp277_;
			gint _tmp278_;
			gpointer _tmp279_;
			ValaDataType* _tmp280_;
			ValaSemanticAnalyzer* _tmp281_;
			ValaSemanticAnalyzer* _tmp282_;
			ValaDataType* _tmp283_;
			_tmp274_ = _error_type_index;
			_error_type_index = _tmp274_ + 1;
			_tmp275_ = _error_type_index;
			_tmp276_ = _error_type_size;
			if (!(_tmp275_ < _tmp276_)) {
				break;
			}
			_tmp277_ = _error_type_list;
			_tmp278_ = _error_type_index;
			_tmp279_ = vala_list_get (_tmp277_, _tmp278_);
			error_type = (ValaDataType*) _tmp279_;
			_tmp280_ = error_type;
			vala_code_node_check ((ValaCodeNode*) _tmp280_, context);
			_tmp281_ = vala_code_context_get_analyzer (context);
			_tmp282_ = _tmp281_;
			_tmp283_ = error_type;
			if (!vala_semantic_analyzer_is_type_accessible (_tmp282_, (ValaSymbol*) self, _tmp283_)) {
				ValaSourceReference* _tmp284_;
				ValaSourceReference* _tmp285_;
				ValaDataType* _tmp286_;
				gchar* _tmp287_;
				gchar* _tmp288_;
				gchar* _tmp289_;
				gchar* _tmp290_;
				gchar* _tmp291_;
				gchar* _tmp292_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp284_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp285_ = _tmp284_;
				_tmp286_ = error_type;
				_tmp287_ = vala_code_node_to_string ((ValaCodeNode*) _tmp286_);
				_tmp288_ = _tmp287_;
				_tmp289_ = vala_symbol_get_full_name ((ValaSymbol*) self);
				_tmp290_ = _tmp289_;
				_tmp291_ = g_strdup_printf ("error type `%s` is less accessible than method `%s`", _tmp288_, _tmp290_);
				_tmp292_ = _tmp291_;
				vala_report_error (_tmp285_, _tmp292_);
				_g_free0 (_tmp292_);
				_g_free0 (_tmp290_);
				_g_free0 (_tmp288_);
				result = FALSE;
				_vala_code_node_unref0 (error_type);
				_vala_iterable_unref0 (_error_type_list);
				_vala_code_node_unref0 (init_attr);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_vala_code_node_unref0 (error_type);
		}
		_vala_iterable_unref0 (_error_type_list);
	}
	_tmp293_ = vala_subroutine_get_result_var ((ValaSubroutine*) self);
	_tmp294_ = _tmp293_;
	if (_tmp294_ != NULL) {
		ValaLocalVariable* _tmp295_;
		ValaLocalVariable* _tmp296_;
		_tmp295_ = vala_subroutine_get_result_var ((ValaSubroutine*) self);
		_tmp296_ = _tmp295_;
		vala_code_node_check ((ValaCodeNode*) _tmp296_, context);
	}
	_tmp297_ = self->priv->preconditions;
	if (_tmp297_ != NULL) {
		{
			ValaList* _precondition_list = NULL;
			ValaList* _tmp298_;
			ValaList* _tmp299_;
			gint _precondition_size = 0;
			ValaList* _tmp300_;
			gint _tmp301_;
			gint _tmp302_;
			gint _precondition_index = 0;
			_tmp298_ = self->priv->preconditions;
			_tmp299_ = _vala_iterable_ref0 (_tmp298_);
			_precondition_list = _tmp299_;
			_tmp300_ = _precondition_list;
			_tmp301_ = vala_collection_get_size ((ValaCollection*) _tmp300_);
			_tmp302_ = _tmp301_;
			_precondition_size = _tmp302_;
			_precondition_index = -1;
			while (TRUE) {
				gint _tmp303_;
				gint _tmp304_;
				gint _tmp305_;
				ValaExpression* precondition = NULL;
				ValaList* _tmp306_;
				gint _tmp307_;
				gpointer _tmp308_;
				ValaExpression* _tmp309_;
				_tmp303_ = _precondition_index;
				_precondition_index = _tmp303_ + 1;
				_tmp304_ = _precondition_index;
				_tmp305_ = _precondition_size;
				if (!(_tmp304_ < _tmp305_)) {
					break;
				}
				_tmp306_ = _precondition_list;
				_tmp307_ = _precondition_index;
				_tmp308_ = vala_list_get (_tmp306_, _tmp307_);
				precondition = (ValaExpression*) _tmp308_;
				_tmp309_ = precondition;
				vala_code_node_check ((ValaCodeNode*) _tmp309_, context);
				_vala_code_node_unref0 (precondition);
			}
			_vala_iterable_unref0 (_precondition_list);
		}
	}
	_tmp310_ = self->priv->postconditions;
	if (_tmp310_ != NULL) {
		{
			ValaList* _postcondition_list = NULL;
			ValaList* _tmp311_;
			ValaList* _tmp312_;
			gint _postcondition_size = 0;
			ValaList* _tmp313_;
			gint _tmp314_;
			gint _tmp315_;
			gint _postcondition_index = 0;
			_tmp311_ = self->priv->postconditions;
			_tmp312_ = _vala_iterable_ref0 (_tmp311_);
			_postcondition_list = _tmp312_;
			_tmp313_ = _postcondition_list;
			_tmp314_ = vala_collection_get_size ((ValaCollection*) _tmp313_);
			_tmp315_ = _tmp314_;
			_postcondition_size = _tmp315_;
			_postcondition_index = -1;
			while (TRUE) {
				gint _tmp316_;
				gint _tmp317_;
				gint _tmp318_;
				ValaExpression* postcondition = NULL;
				ValaList* _tmp319_;
				gint _tmp320_;
				gpointer _tmp321_;
				ValaExpression* _tmp322_;
				_tmp316_ = _postcondition_index;
				_postcondition_index = _tmp316_ + 1;
				_tmp317_ = _postcondition_index;
				_tmp318_ = _postcondition_size;
				if (!(_tmp317_ < _tmp318_)) {
					break;
				}
				_tmp319_ = _postcondition_list;
				_tmp320_ = _postcondition_index;
				_tmp321_ = vala_list_get (_tmp319_, _tmp320_);
				postcondition = (ValaExpression*) _tmp321_;
				_tmp322_ = postcondition;
				vala_code_node_check ((ValaCodeNode*) _tmp322_, context);
				_vala_code_node_unref0 (postcondition);
			}
			_vala_iterable_unref0 (_postcondition_list);
		}
	}
	_tmp323_ = vala_subroutine_get_body ((ValaSubroutine*) self);
	_tmp324_ = _tmp323_;
	if (_tmp324_ != NULL) {
		ValaBlock* _tmp325_;
		ValaBlock* _tmp326_;
		_tmp325_ = vala_subroutine_get_body ((ValaSubroutine*) self);
		_tmp326_ = _tmp325_;
		vala_code_node_check ((ValaCodeNode*) _tmp326_, context);
	}
	_tmp327_ = vala_code_context_get_analyzer (context);
	_tmp328_ = _tmp327_;
	_tmp329_ = vala_semantic_analyzer_get_current_struct (_tmp328_);
	_tmp330_ = _tmp329_;
	if (_tmp330_ != NULL) {
		gboolean _tmp331_ = FALSE;
		gboolean _tmp332_ = FALSE;
		gboolean _tmp333_;
		_tmp333_ = self->priv->_is_abstract;
		if (_tmp333_) {
			_tmp332_ = TRUE;
		} else {
			gboolean _tmp334_;
			_tmp334_ = self->priv->_is_virtual;
			_tmp332_ = _tmp334_;
		}
		if (_tmp332_) {
			_tmp331_ = TRUE;
		} else {
			gboolean _tmp335_;
			_tmp335_ = self->priv->_overrides;
			_tmp331_ = _tmp335_;
		}
		if (_tmp331_) {
			ValaSourceReference* _tmp336_;
			ValaSourceReference* _tmp337_;
			gchar* _tmp338_;
			gchar* _tmp339_;
			gchar* _tmp340_;
			gchar* _tmp341_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp336_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp337_ = _tmp336_;
			_tmp338_ = vala_symbol_get_full_name ((ValaSymbol*) self);
			_tmp339_ = _tmp338_;
			_tmp340_ = g_strdup_printf ("A struct member `%s' cannot be marked as override, virtual, or abstrac" \
"t", _tmp339_);
			_tmp341_ = _tmp340_;
			vala_report_error (_tmp337_, _tmp341_);
			_g_free0 (_tmp341_);
			_g_free0 (_tmp339_);
			result = FALSE;
			_vala_code_node_unref0 (init_attr);
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
	} else {
		gboolean _tmp342_ = FALSE;
		gboolean _tmp343_;
		_tmp343_ = self->priv->_overrides;
		if (_tmp343_) {
			ValaMethod* _tmp344_;
			ValaMethod* _tmp345_;
			_tmp344_ = vala_method_get_base_method (self);
			_tmp345_ = _tmp344_;
			_tmp342_ = _tmp345_ == NULL;
		} else {
			_tmp342_ = FALSE;
		}
		if (_tmp342_) {
			ValaSourceReference* _tmp346_;
			ValaSourceReference* _tmp347_;
			gchar* _tmp348_;
			gchar* _tmp349_;
			gchar* _tmp350_;
			gchar* _tmp351_;
			_tmp346_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp347_ = _tmp346_;
			_tmp348_ = vala_symbol_get_full_name ((ValaSymbol*) self);
			_tmp349_ = _tmp348_;
			_tmp350_ = g_strdup_printf ("`%s': no suitable method found to override", _tmp349_);
			_tmp351_ = _tmp350_;
			vala_report_error (_tmp347_, _tmp351_);
			_g_free0 (_tmp351_);
			_g_free0 (_tmp349_);
		} else {
			gboolean _tmp352_ = FALSE;
			gboolean _tmp353_ = FALSE;
			gboolean _tmp354_ = FALSE;
			gboolean _tmp355_;
			_tmp355_ = self->priv->_is_abstract;
			if (_tmp355_) {
				_tmp354_ = TRUE;
			} else {
				gboolean _tmp356_;
				_tmp356_ = self->priv->_is_virtual;
				_tmp354_ = _tmp356_;
			}
			if (_tmp354_) {
				_tmp353_ = TRUE;
			} else {
				gboolean _tmp357_;
				_tmp357_ = self->priv->_overrides;
				_tmp353_ = _tmp357_;
			}
			if (_tmp353_) {
				ValaSymbolAccessibility _tmp358_;
				ValaSymbolAccessibility _tmp359_;
				_tmp358_ = vala_symbol_get_access ((ValaSymbol*) self);
				_tmp359_ = _tmp358_;
				_tmp352_ = _tmp359_ == VALA_SYMBOL_ACCESSIBILITY_PRIVATE;
			} else {
				_tmp352_ = FALSE;
			}
			if (_tmp352_) {
				ValaSourceReference* _tmp360_;
				ValaSourceReference* _tmp361_;
				gchar* _tmp362_;
				gchar* _tmp363_;
				gchar* _tmp364_;
				gchar* _tmp365_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp360_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp361_ = _tmp360_;
				_tmp362_ = vala_symbol_get_full_name ((ValaSymbol*) self);
				_tmp363_ = _tmp362_;
				_tmp364_ = g_strdup_printf ("Private member `%s' cannot be marked as override, virtual, or abstract", _tmp363_);
				_tmp365_ = _tmp364_;
				vala_report_error (_tmp361_, _tmp365_);
				_g_free0 (_tmp365_);
				_g_free0 (_tmp363_);
				result = FALSE;
				_vala_code_node_unref0 (init_attr);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
		}
	}
	_tmp368_ = vala_method_get_base_interface_type (self);
	_tmp369_ = _tmp368_;
	if (_tmp369_ != NULL) {
		ValaMethod* _tmp370_;
		ValaMethod* _tmp371_;
		_tmp370_ = vala_method_get_base_interface_method (self);
		_tmp371_ = _tmp370_;
		_tmp367_ = _tmp371_ != NULL;
	} else {
		_tmp367_ = FALSE;
	}
	if (_tmp367_) {
		ValaSymbol* _tmp372_;
		ValaSymbol* _tmp373_;
		_tmp372_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp373_ = _tmp372_;
		_tmp366_ = VALA_IS_CLASS (_tmp373_);
	} else {
		_tmp366_ = FALSE;
	}
	if (_tmp366_) {
		ValaClass* cl = NULL;
		ValaSymbol* _tmp374_;
		ValaSymbol* _tmp375_;
		ValaClass* _tmp376_;
		_tmp374_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp375_ = _tmp374_;
		_tmp376_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp375_, VALA_TYPE_CLASS, ValaClass));
		cl = _tmp376_;
		{
			ValaList* _m_list = NULL;
			ValaClass* _tmp377_;
			ValaList* _tmp378_;
			gint _m_size = 0;
			ValaList* _tmp379_;
			gint _tmp380_;
			gint _tmp381_;
			gint _m_index = 0;
			_tmp377_ = cl;
			_tmp378_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) _tmp377_);
			_m_list = _tmp378_;
			_tmp379_ = _m_list;
			_tmp380_ = vala_collection_get_size ((ValaCollection*) _tmp379_);
			_tmp381_ = _tmp380_;
			_m_size = _tmp381_;
			_m_index = -1;
			while (TRUE) {
				gint _tmp382_;
				gint _tmp383_;
				gint _tmp384_;
				ValaMethod* m = NULL;
				ValaList* _tmp385_;
				gint _tmp386_;
				gpointer _tmp387_;
				gboolean _tmp388_ = FALSE;
				ValaMethod* _tmp389_;
				_tmp382_ = _m_index;
				_m_index = _tmp382_ + 1;
				_tmp383_ = _m_index;
				_tmp384_ = _m_size;
				if (!(_tmp383_ < _tmp384_)) {
					break;
				}
				_tmp385_ = _m_list;
				_tmp386_ = _m_index;
				_tmp387_ = vala_list_get (_tmp385_, _tmp386_);
				m = (ValaMethod*) _tmp387_;
				_tmp389_ = m;
				if (_tmp389_ != self) {
					ValaMethod* _tmp390_;
					ValaMethod* _tmp391_;
					ValaMethod* _tmp392_;
					ValaMethod* _tmp393_;
					ValaMethod* _tmp394_;
					_tmp390_ = m;
					_tmp391_ = vala_method_get_base_interface_method (_tmp390_);
					_tmp392_ = _tmp391_;
					_tmp393_ = vala_method_get_base_interface_method (self);
					_tmp394_ = _tmp393_;
					_tmp388_ = _tmp392_ == _tmp394_;
				} else {
					_tmp388_ = FALSE;
				}
				if (_tmp388_) {
					ValaMethod* _tmp395_;
					ValaMethod* _tmp396_;
					ValaSourceReference* _tmp397_;
					ValaSourceReference* _tmp398_;
					ValaClass* _tmp399_;
					gchar* _tmp400_;
					gchar* _tmp401_;
					ValaMethod* _tmp402_;
					ValaMethod* _tmp403_;
					gchar* _tmp404_;
					gchar* _tmp405_;
					gchar* _tmp406_;
					gchar* _tmp407_;
					ValaMethod* _tmp408_;
					ValaSourceReference* _tmp409_;
					ValaSourceReference* _tmp410_;
					ValaMethod* _tmp411_;
					ValaMethod* _tmp412_;
					gchar* _tmp413_;
					gchar* _tmp414_;
					gchar* _tmp415_;
					gchar* _tmp416_;
					_tmp395_ = m;
					vala_code_node_set_checked ((ValaCodeNode*) _tmp395_, TRUE);
					_tmp396_ = m;
					vala_code_node_set_error ((ValaCodeNode*) _tmp396_, TRUE);
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp397_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp398_ = _tmp397_;
					_tmp399_ = cl;
					_tmp400_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp399_);
					_tmp401_ = _tmp400_;
					_tmp402_ = vala_method_get_base_interface_method (self);
					_tmp403_ = _tmp402_;
					_tmp404_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp403_);
					_tmp405_ = _tmp404_;
					_tmp406_ = g_strdup_printf ("`%s' already contains an implementation for `%s'", _tmp401_, _tmp405_);
					_tmp407_ = _tmp406_;
					vala_report_error (_tmp398_, _tmp407_);
					_g_free0 (_tmp407_);
					_g_free0 (_tmp405_);
					_g_free0 (_tmp401_);
					_tmp408_ = m;
					_tmp409_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp408_);
					_tmp410_ = _tmp409_;
					_tmp411_ = vala_method_get_base_interface_method (self);
					_tmp412_ = _tmp411_;
					_tmp413_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp412_);
					_tmp414_ = _tmp413_;
					_tmp415_ = g_strdup_printf ("previous implementation of `%s' was here", _tmp414_);
					_tmp416_ = _tmp415_;
					vala_report_notice (_tmp410_, _tmp416_);
					_g_free0 (_tmp416_);
					_g_free0 (_tmp414_);
					result = FALSE;
					_vala_code_node_unref0 (m);
					_vala_iterable_unref0 (_m_list);
					_vala_code_node_unref0 (cl);
					_vala_code_node_unref0 (init_attr);
					_vala_code_node_unref0 (old_symbol);
					_vala_source_file_unref0 (old_source_file);
					return result;
				}
				_vala_code_node_unref0 (m);
			}
			_vala_iterable_unref0 (_m_list);
		}
		_vala_code_node_unref0 (cl);
	}
	_tmp417_ = vala_code_context_get_analyzer (context);
	_tmp418_ = _tmp417_;
	_tmp419_ = old_source_file;
	vala_semantic_analyzer_set_current_source_file (_tmp418_, _tmp419_);
	_tmp420_ = vala_code_context_get_analyzer (context);
	_tmp421_ = _tmp420_;
	_tmp422_ = old_symbol;
	vala_semantic_analyzer_set_current_symbol (_tmp421_, _tmp422_);
	_tmp426_ = vala_symbol_get_external_package ((ValaSymbol*) self);
	_tmp427_ = _tmp426_;
	if (!_tmp427_) {
		gboolean _tmp428_;
		_tmp428_ = self->priv->_overrides;
		_tmp425_ = !_tmp428_;
	} else {
		_tmp425_ = FALSE;
	}
	if (_tmp425_) {
		gboolean _tmp429_;
		gboolean _tmp430_;
		_tmp429_ = vala_symbol_get_hides ((ValaSymbol*) self);
		_tmp430_ = _tmp429_;
		_tmp424_ = !_tmp430_;
	} else {
		_tmp424_ = FALSE;
	}
	if (_tmp424_) {
		ValaSymbol* _tmp431_;
		ValaSymbol* _tmp432_;
		_tmp431_ = vala_symbol_get_hidden_member ((ValaSymbol*) self);
		_tmp432_ = _tmp431_;
		_tmp423_ = _tmp432_ != NULL;
		_vala_code_node_unref0 (_tmp432_);
	} else {
		_tmp423_ = FALSE;
	}
	if (_tmp423_) {
		ValaSourceReference* _tmp433_;
		ValaSourceReference* _tmp434_;
		gchar* _tmp435_;
		gchar* _tmp436_;
		ValaSymbol* _tmp437_;
		ValaSymbol* _tmp438_;
		gchar* _tmp439_;
		gchar* _tmp440_;
		gchar* _tmp441_;
		gchar* _tmp442_;
		_tmp433_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp434_ = _tmp433_;
		_tmp435_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp436_ = _tmp435_;
		_tmp437_ = vala_symbol_get_hidden_member ((ValaSymbol*) self);
		_tmp438_ = _tmp437_;
		_tmp439_ = vala_symbol_get_full_name (_tmp438_);
		_tmp440_ = _tmp439_;
		_tmp441_ = g_strdup_printf ("%s hides inherited method `%s'. Use the `new' keyword if hiding was in" \
"tentional", _tmp436_, _tmp440_);
		_tmp442_ = _tmp441_;
		vala_report_warning (_tmp434_, _tmp442_);
		_g_free0 (_tmp442_);
		_g_free0 (_tmp440_);
		_vala_code_node_unref0 (_tmp438_);
		_g_free0 (_tmp436_);
	}
	_tmp443_ = vala_code_context_get_analyzer (context);
	_tmp444_ = _tmp443_;
	_tmp445_ = vala_callable_get_return_type ((ValaCallable*) self);
	_tmp446_ = _tmp445_;
	if (!vala_semantic_analyzer_is_type_accessible (_tmp444_, (ValaSymbol*) self, _tmp446_)) {
		ValaSourceReference* _tmp447_;
		ValaSourceReference* _tmp448_;
		ValaDataType* _tmp449_;
		ValaDataType* _tmp450_;
		gchar* _tmp451_;
		gchar* _tmp452_;
		gchar* _tmp453_;
		gchar* _tmp454_;
		gchar* _tmp455_;
		gchar* _tmp456_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp447_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp448_ = _tmp447_;
		_tmp449_ = vala_callable_get_return_type ((ValaCallable*) self);
		_tmp450_ = _tmp449_;
		_tmp451_ = vala_code_node_to_string ((ValaCodeNode*) _tmp450_);
		_tmp452_ = _tmp451_;
		_tmp453_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp454_ = _tmp453_;
		_tmp455_ = g_strdup_printf ("return type `%s` is less accessible than method `%s`", _tmp452_, _tmp454_);
		_tmp456_ = _tmp455_;
		vala_report_error (_tmp448_, _tmp456_);
		_g_free0 (_tmp456_);
		_g_free0 (_tmp454_);
		_g_free0 (_tmp452_);
		result = FALSE;
		_vala_code_node_unref0 (init_attr);
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	{
		ValaList* _precondition_list = NULL;
		ValaList* _tmp457_;
		gint _precondition_size = 0;
		ValaList* _tmp458_;
		gint _tmp459_;
		gint _tmp460_;
		gint _precondition_index = 0;
		_tmp457_ = vala_method_get_preconditions (self);
		_precondition_list = _tmp457_;
		_tmp458_ = _precondition_list;
		_tmp459_ = vala_collection_get_size ((ValaCollection*) _tmp458_);
		_tmp460_ = _tmp459_;
		_precondition_size = _tmp460_;
		_precondition_index = -1;
		while (TRUE) {
			gint _tmp461_;
			gint _tmp462_;
			gint _tmp463_;
			ValaExpression* precondition = NULL;
			ValaList* _tmp464_;
			gint _tmp465_;
			gpointer _tmp466_;
			ValaExpression* _tmp467_;
			gboolean _tmp468_;
			gboolean _tmp469_;
			ValaExpression* _tmp470_;
			ValaDataType* _tmp471_;
			ValaDataType* _tmp472_;
			ValaSemanticAnalyzer* _tmp473_;
			ValaSemanticAnalyzer* _tmp474_;
			ValaDataType* _tmp475_;
			_tmp461_ = _precondition_index;
			_precondition_index = _tmp461_ + 1;
			_tmp462_ = _precondition_index;
			_tmp463_ = _precondition_size;
			if (!(_tmp462_ < _tmp463_)) {
				break;
			}
			_tmp464_ = _precondition_list;
			_tmp465_ = _precondition_index;
			_tmp466_ = vala_list_get (_tmp464_, _tmp465_);
			precondition = (ValaExpression*) _tmp466_;
			_tmp467_ = precondition;
			_tmp468_ = vala_code_node_get_error ((ValaCodeNode*) _tmp467_);
			_tmp469_ = _tmp468_;
			if (_tmp469_) {
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				result = FALSE;
				_vala_code_node_unref0 (precondition);
				_vala_iterable_unref0 (_precondition_list);
				_vala_code_node_unref0 (init_attr);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_tmp470_ = precondition;
			_tmp471_ = vala_expression_get_value_type (_tmp470_);
			_tmp472_ = _tmp471_;
			_tmp473_ = vala_code_context_get_analyzer (context);
			_tmp474_ = _tmp473_;
			_tmp475_ = _tmp474_->bool_type;
			if (!vala_data_type_compatible (_tmp472_, _tmp475_)) {
				ValaExpression* _tmp476_;
				ValaSourceReference* _tmp477_;
				ValaSourceReference* _tmp478_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp476_ = precondition;
				_tmp477_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp476_);
				_tmp478_ = _tmp477_;
				vala_report_error (_tmp478_, "Precondition must be boolean");
				result = FALSE;
				_vala_code_node_unref0 (precondition);
				_vala_iterable_unref0 (_precondition_list);
				_vala_code_node_unref0 (init_attr);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_vala_code_node_unref0 (precondition);
		}
		_vala_iterable_unref0 (_precondition_list);
	}
	{
		ValaList* _postcondition_list = NULL;
		ValaList* _tmp479_;
		gint _postcondition_size = 0;
		ValaList* _tmp480_;
		gint _tmp481_;
		gint _tmp482_;
		gint _postcondition_index = 0;
		_tmp479_ = vala_method_get_postconditions (self);
		_postcondition_list = _tmp479_;
		_tmp480_ = _postcondition_list;
		_tmp481_ = vala_collection_get_size ((ValaCollection*) _tmp480_);
		_tmp482_ = _tmp481_;
		_postcondition_size = _tmp482_;
		_postcondition_index = -1;
		while (TRUE) {
			gint _tmp483_;
			gint _tmp484_;
			gint _tmp485_;
			ValaExpression* postcondition = NULL;
			ValaList* _tmp486_;
			gint _tmp487_;
			gpointer _tmp488_;
			ValaExpression* _tmp489_;
			gboolean _tmp490_;
			gboolean _tmp491_;
			ValaExpression* _tmp492_;
			ValaDataType* _tmp493_;
			ValaDataType* _tmp494_;
			ValaSemanticAnalyzer* _tmp495_;
			ValaSemanticAnalyzer* _tmp496_;
			ValaDataType* _tmp497_;
			_tmp483_ = _postcondition_index;
			_postcondition_index = _tmp483_ + 1;
			_tmp484_ = _postcondition_index;
			_tmp485_ = _postcondition_size;
			if (!(_tmp484_ < _tmp485_)) {
				break;
			}
			_tmp486_ = _postcondition_list;
			_tmp487_ = _postcondition_index;
			_tmp488_ = vala_list_get (_tmp486_, _tmp487_);
			postcondition = (ValaExpression*) _tmp488_;
			_tmp489_ = postcondition;
			_tmp490_ = vala_code_node_get_error ((ValaCodeNode*) _tmp489_);
			_tmp491_ = _tmp490_;
			if (_tmp491_) {
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				result = FALSE;
				_vala_code_node_unref0 (postcondition);
				_vala_iterable_unref0 (_postcondition_list);
				_vala_code_node_unref0 (init_attr);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_tmp492_ = postcondition;
			_tmp493_ = vala_expression_get_value_type (_tmp492_);
			_tmp494_ = _tmp493_;
			_tmp495_ = vala_code_context_get_analyzer (context);
			_tmp496_ = _tmp495_;
			_tmp497_ = _tmp496_->bool_type;
			if (!vala_data_type_compatible (_tmp494_, _tmp497_)) {
				ValaExpression* _tmp498_;
				ValaSourceReference* _tmp499_;
				ValaSourceReference* _tmp500_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp498_ = postcondition;
				_tmp499_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp498_);
				_tmp500_ = _tmp499_;
				vala_report_error (_tmp500_, "Postcondition must be boolean");
				result = FALSE;
				_vala_code_node_unref0 (postcondition);
				_vala_iterable_unref0 (_postcondition_list);
				_vala_code_node_unref0 (init_attr);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_vala_code_node_unref0 (postcondition);
		}
		_vala_iterable_unref0 (_postcondition_list);
	}
	_tmp502_ = vala_subroutine_get_body ((ValaSubroutine*) self);
	_tmp503_ = _tmp502_;
	if (_tmp503_ != NULL) {
		ValaBlock* _tmp504_;
		ValaBlock* _tmp505_;
		gboolean _tmp506_;
		gboolean _tmp507_;
		_tmp504_ = vala_subroutine_get_body ((ValaSubroutine*) self);
		_tmp505_ = _tmp504_;
		_tmp506_ = vala_code_node_get_error ((ValaCodeNode*) _tmp505_);
		_tmp507_ = _tmp506_;
		_tmp501_ = !_tmp507_;
	} else {
		_tmp501_ = FALSE;
	}
	if (_tmp501_) {
		{
			ValaList* _body_error_type_list = NULL;
			ValaBlock* _tmp508_;
			ValaBlock* _tmp509_;
			ValaList* _tmp510_;
			gint _body_error_type_size = 0;
			ValaList* _tmp511_;
			gint _tmp512_;
			gint _tmp513_;
			gint _body_error_type_index = 0;
			_tmp508_ = vala_subroutine_get_body ((ValaSubroutine*) self);
			_tmp509_ = _tmp508_;
			_tmp510_ = vala_code_node_get_error_types ((ValaCodeNode*) _tmp509_);
			_body_error_type_list = _tmp510_;
			_tmp511_ = _body_error_type_list;
			_tmp512_ = vala_collection_get_size ((ValaCollection*) _tmp511_);
			_tmp513_ = _tmp512_;
			_body_error_type_size = _tmp513_;
			_body_error_type_index = -1;
			while (TRUE) {
				gint _tmp514_;
				gint _tmp515_;
				gint _tmp516_;
				ValaDataType* body_error_type = NULL;
				ValaList* _tmp517_;
				gint _tmp518_;
				gpointer _tmp519_;
				gboolean can_propagate_error = FALSE;
				gboolean _tmp532_ = FALSE;
				ValaDataType* _tmp533_;
				gboolean is_dynamic_error = FALSE;
				gboolean _tmp537_ = FALSE;
				gboolean _tmp538_;
				_tmp514_ = _body_error_type_index;
				_body_error_type_index = _tmp514_ + 1;
				_tmp515_ = _body_error_type_index;
				_tmp516_ = _body_error_type_size;
				if (!(_tmp515_ < _tmp516_)) {
					break;
				}
				_tmp517_ = _body_error_type_list;
				_tmp518_ = _body_error_type_index;
				_tmp519_ = vala_list_get (_tmp517_, _tmp518_);
				body_error_type = (ValaDataType*) _tmp519_;
				can_propagate_error = FALSE;
				{
					ValaList* _method_error_type_list = NULL;
					ValaList* _tmp520_;
					gint _method_error_type_size = 0;
					ValaList* _tmp521_;
					gint _tmp522_;
					gint _tmp523_;
					gint _method_error_type_index = 0;
					_tmp520_ = vala_code_node_get_error_types ((ValaCodeNode*) self);
					_method_error_type_list = _tmp520_;
					_tmp521_ = _method_error_type_list;
					_tmp522_ = vala_collection_get_size ((ValaCollection*) _tmp521_);
					_tmp523_ = _tmp522_;
					_method_error_type_size = _tmp523_;
					_method_error_type_index = -1;
					while (TRUE) {
						gint _tmp524_;
						gint _tmp525_;
						gint _tmp526_;
						ValaDataType* method_error_type = NULL;
						ValaList* _tmp527_;
						gint _tmp528_;
						gpointer _tmp529_;
						ValaDataType* _tmp530_;
						ValaDataType* _tmp531_;
						_tmp524_ = _method_error_type_index;
						_method_error_type_index = _tmp524_ + 1;
						_tmp525_ = _method_error_type_index;
						_tmp526_ = _method_error_type_size;
						if (!(_tmp525_ < _tmp526_)) {
							break;
						}
						_tmp527_ = _method_error_type_list;
						_tmp528_ = _method_error_type_index;
						_tmp529_ = vala_list_get (_tmp527_, _tmp528_);
						method_error_type = (ValaDataType*) _tmp529_;
						_tmp530_ = body_error_type;
						_tmp531_ = method_error_type;
						if (vala_data_type_compatible (_tmp530_, _tmp531_)) {
							can_propagate_error = TRUE;
						}
						_vala_code_node_unref0 (method_error_type);
					}
					_vala_iterable_unref0 (_method_error_type_list);
				}
				_tmp533_ = body_error_type;
				if (VALA_IS_ERROR_TYPE (_tmp533_)) {
					ValaDataType* _tmp534_;
					gboolean _tmp535_;
					gboolean _tmp536_;
					_tmp534_ = body_error_type;
					_tmp535_ = vala_error_type_get_dynamic_error (G_TYPE_CHECK_INSTANCE_CAST (_tmp534_, VALA_TYPE_ERROR_TYPE, ValaErrorType));
					_tmp536_ = _tmp535_;
					_tmp532_ = _tmp536_;
				} else {
					_tmp532_ = FALSE;
				}
				is_dynamic_error = _tmp532_;
				_tmp538_ = can_propagate_error;
				if (!_tmp538_) {
					gboolean _tmp539_;
					_tmp539_ = is_dynamic_error;
					_tmp537_ = !_tmp539_;
				} else {
					_tmp537_ = FALSE;
				}
				if (_tmp537_) {
					ValaDataType* _tmp540_;
					ValaSourceReference* _tmp541_;
					ValaSourceReference* _tmp542_;
					ValaDataType* _tmp543_;
					gchar* _tmp544_;
					gchar* _tmp545_;
					gchar* _tmp546_;
					gchar* _tmp547_;
					_tmp540_ = body_error_type;
					_tmp541_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp540_);
					_tmp542_ = _tmp541_;
					_tmp543_ = body_error_type;
					_tmp544_ = vala_code_node_to_string ((ValaCodeNode*) _tmp543_);
					_tmp545_ = _tmp544_;
					_tmp546_ = g_strdup_printf ("unhandled error `%s'", _tmp545_);
					_tmp547_ = _tmp546_;
					vala_report_warning (_tmp542_, _tmp547_);
					_g_free0 (_tmp547_);
					_g_free0 (_tmp545_);
				}
				_vala_code_node_unref0 (body_error_type);
			}
			_vala_iterable_unref0 (_body_error_type_list);
		}
	}
	if (!VALA_IS_CREATION_METHOD (self)) {
		ValaMemberBinding _tmp553_;
		_tmp553_ = self->priv->_binding;
		_tmp552_ = _tmp553_ == VALA_MEMBER_BINDING_INSTANCE;
	} else {
		_tmp552_ = FALSE;
	}
	if (_tmp552_) {
		gboolean _tmp554_;
		_tmp554_ = self->priv->_overrides;
		_tmp551_ = !_tmp554_;
	} else {
		_tmp551_ = FALSE;
	}
	if (_tmp551_) {
		ValaSymbolAccessibility _tmp555_;
		ValaSymbolAccessibility _tmp556_;
		_tmp555_ = vala_symbol_get_access ((ValaSymbol*) self);
		_tmp556_ = _tmp555_;
		_tmp550_ = _tmp556_ == VALA_SYMBOL_ACCESSIBILITY_PUBLIC;
	} else {
		_tmp550_ = FALSE;
	}
	if (_tmp550_) {
		ValaSymbol* _tmp557_;
		ValaSymbol* _tmp558_;
		_tmp557_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp558_ = _tmp557_;
		_tmp549_ = VALA_IS_OBJECT_TYPE_SYMBOL (_tmp558_);
	} else {
		_tmp549_ = FALSE;
	}
	if (_tmp549_) {
		ValaSymbol* _tmp559_;
		ValaSymbol* _tmp560_;
		ValaAttribute* _tmp561_;
		ValaAttribute* _tmp562_;
		_tmp559_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp560_ = _tmp559_;
		_tmp561_ = vala_code_node_get_attribute ((ValaCodeNode*) _tmp560_, "DBus");
		_tmp562_ = _tmp561_;
		_tmp548_ = _tmp562_ != NULL;
		_vala_code_node_unref0 (_tmp562_);
	} else {
		_tmp548_ = FALSE;
	}
	if (_tmp548_) {
		ValaAttribute* dbus_attr = NULL;
		ValaAttribute* _tmp563_;
		gboolean _tmp564_ = FALSE;
		ValaAttribute* _tmp565_;
		_tmp563_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "DBus");
		dbus_attr = _tmp563_;
		_tmp565_ = dbus_attr;
		if (_tmp565_ == NULL) {
			_tmp564_ = TRUE;
		} else {
			ValaAttribute* _tmp566_;
			_tmp566_ = dbus_attr;
			_tmp564_ = vala_attribute_get_bool (_tmp566_, "visible", TRUE);
		}
		if (_tmp564_) {
			gboolean throws_gerror = FALSE;
			gboolean throws_gioerror = FALSE;
			gboolean throws_gdbuserror = FALSE;
			gboolean _tmp586_ = FALSE;
			gboolean _tmp587_;
			throws_gerror = FALSE;
			throws_gioerror = FALSE;
			throws_gdbuserror = FALSE;
			{
				ValaList* _error_type_list = NULL;
				ValaList* _tmp567_;
				gint _error_type_size = 0;
				ValaList* _tmp568_;
				gint _tmp569_;
				gint _tmp570_;
				gint _error_type_index = 0;
				_tmp567_ = vala_code_node_get_error_types ((ValaCodeNode*) self);
				_error_type_list = _tmp567_;
				_tmp568_ = _error_type_list;
				_tmp569_ = vala_collection_get_size ((ValaCollection*) _tmp568_);
				_tmp570_ = _tmp569_;
				_error_type_size = _tmp570_;
				_error_type_index = -1;
				while (TRUE) {
					gint _tmp571_;
					gint _tmp572_;
					gint _tmp573_;
					ValaDataType* error_type = NULL;
					ValaList* _tmp574_;
					gint _tmp575_;
					gpointer _tmp576_;
					ValaDataType* _tmp577_;
					ValaErrorDomain* error_domain = NULL;
					ValaDataType* _tmp578_;
					ValaErrorDomain* _tmp579_;
					ValaErrorDomain* _tmp580_;
					ValaErrorDomain* _tmp581_;
					gchar* full_error_domain = NULL;
					ValaErrorDomain* _tmp582_;
					gchar* _tmp583_;
					const gchar* _tmp584_;
					_tmp571_ = _error_type_index;
					_error_type_index = _tmp571_ + 1;
					_tmp572_ = _error_type_index;
					_tmp573_ = _error_type_size;
					if (!(_tmp572_ < _tmp573_)) {
						break;
					}
					_tmp574_ = _error_type_list;
					_tmp575_ = _error_type_index;
					_tmp576_ = vala_list_get (_tmp574_, _tmp575_);
					error_type = (ValaDataType*) _tmp576_;
					_tmp577_ = error_type;
					if (!VALA_IS_ERROR_TYPE (_tmp577_)) {
						_vala_code_node_unref0 (error_type);
						continue;
					}
					_tmp578_ = error_type;
					_tmp579_ = vala_error_type_get_error_domain (G_TYPE_CHECK_INSTANCE_CAST (_tmp578_, VALA_TYPE_ERROR_TYPE, ValaErrorType));
					_tmp580_ = _tmp579_;
					error_domain = _tmp580_;
					_tmp581_ = error_domain;
					if (_tmp581_ == NULL) {
						throws_gerror = TRUE;
						_vala_code_node_unref0 (error_type);
						break;
					}
					_tmp582_ = error_domain;
					_tmp583_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp582_);
					full_error_domain = _tmp583_;
					_tmp584_ = full_error_domain;
					if (g_strcmp0 (_tmp584_, "GLib.IOError") == 0) {
						throws_gioerror = TRUE;
					} else {
						const gchar* _tmp585_;
						_tmp585_ = full_error_domain;
						if (g_strcmp0 (_tmp585_, "GLib.DBusError") == 0) {
							throws_gdbuserror = TRUE;
						}
					}
					_g_free0 (full_error_domain);
					_vala_code_node_unref0 (error_type);
				}
				_vala_iterable_unref0 (_error_type_list);
			}
			_tmp587_ = throws_gerror;
			if (!_tmp587_) {
				gboolean _tmp588_ = FALSE;
				gboolean _tmp589_;
				_tmp589_ = throws_gioerror;
				if (_tmp589_) {
					gboolean _tmp590_;
					_tmp590_ = throws_gdbuserror;
					_tmp588_ = _tmp590_;
				} else {
					_tmp588_ = FALSE;
				}
				_tmp586_ = !_tmp588_;
			} else {
				_tmp586_ = FALSE;
			}
			if (_tmp586_) {
				ValaSourceReference* _tmp591_;
				ValaSourceReference* _tmp592_;
				_tmp591_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp592_ = _tmp591_;
				vala_report_warning (_tmp592_, "DBus methods are recommended to throw at least `GLib.Error' or `GLib.D" \
"BusError, GLib.IOError'");
			}
		}
		_vala_code_node_unref0 (dbus_attr);
	}
	if (vala_method_is_possible_entry_point (self, context)) {
		ValaMethod* _tmp593_;
		ValaMethod* _tmp594_;
		gboolean _tmp603_;
		gboolean _tmp604_;
		gboolean _tmp607_;
		gboolean _tmp610_;
		_tmp593_ = vala_code_context_get_entry_point (context);
		_tmp594_ = _tmp593_;
		if (_tmp594_ != NULL) {
			ValaSourceReference* _tmp595_;
			ValaSourceReference* _tmp596_;
			ValaMethod* _tmp597_;
			ValaMethod* _tmp598_;
			gchar* _tmp599_;
			gchar* _tmp600_;
			gchar* _tmp601_;
			gchar* _tmp602_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp595_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp596_ = _tmp595_;
			_tmp597_ = vala_code_context_get_entry_point (context);
			_tmp598_ = _tmp597_;
			_tmp599_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp598_);
			_tmp600_ = _tmp599_;
			_tmp601_ = g_strdup_printf ("program already has an entry point `%s'", _tmp600_);
			_tmp602_ = _tmp601_;
			vala_report_error (_tmp596_, _tmp602_);
			_g_free0 (_tmp602_);
			_g_free0 (_tmp600_);
			result = FALSE;
			_vala_code_node_unref0 (init_attr);
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		vala_method_set_entry_point (self, TRUE);
		vala_code_context_set_entry_point (context, self);
		_tmp603_ = vala_code_node_get_tree_can_fail ((ValaCodeNode*) self);
		_tmp604_ = _tmp603_;
		if (_tmp604_) {
			ValaSourceReference* _tmp605_;
			ValaSourceReference* _tmp606_;
			_tmp605_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp606_ = _tmp605_;
			vala_report_error (_tmp606_, "\"main\" method cannot throw errors");
		}
		_tmp607_ = self->priv->_is_inline;
		if (_tmp607_) {
			ValaSourceReference* _tmp608_;
			ValaSourceReference* _tmp609_;
			_tmp608_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp609_ = _tmp608_;
			vala_report_error (_tmp609_, "\"main\" method cannot be inline");
		}
		_tmp610_ = self->priv->_coroutine;
		if (_tmp610_) {
			ValaSourceReference* _tmp611_;
			ValaSourceReference* _tmp612_;
			_tmp611_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp612_ = _tmp611_;
			vala_report_error (_tmp612_, "\"main\" method cannot be async");
		}
	}
	_tmp613_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "GtkCallback");
	_tmp614_ = _tmp613_;
	_tmp615_ = _tmp614_ != NULL;
	_vala_code_node_unref0 (_tmp614_);
	if (_tmp615_) {
		vala_symbol_set_used ((ValaSymbol*) self, TRUE);
	}
	_tmp616_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp617_ = _tmp616_;
	result = !_tmp617_;
	_vala_code_node_unref0 (init_attr);
	_vala_code_node_unref0 (old_symbol);
	_vala_source_file_unref0 (old_source_file);
	return result;
}


static gboolean
vala_method_is_possible_entry_point (ValaMethod* self,
                                     ValaCodeContext* context)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	ValaMemberBinding _tmp14_;
	ValaDataType* _tmp15_;
	ValaDataType* _tmp16_;
	ValaList* params = NULL;
	ValaList* _tmp26_;
	ValaList* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	ValaList* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	ValaIterator* params_it = NULL;
	ValaList* _tmp33_;
	ValaIterator* _tmp34_;
	ValaIterator* _tmp35_;
	ValaParameter* param = NULL;
	ValaIterator* _tmp36_;
	gpointer _tmp37_;
	ValaParameter* _tmp38_;
	ValaParameterDirection _tmp39_;
	ValaParameterDirection _tmp40_;
	ValaParameter* _tmp41_;
	ValaDataType* _tmp42_;
	ValaDataType* _tmp43_;
	ValaArrayType* array_type = NULL;
	ValaParameter* _tmp44_;
	ValaDataType* _tmp45_;
	ValaDataType* _tmp46_;
	ValaArrayType* _tmp47_;
	ValaArrayType* _tmp48_;
	ValaDataType* _tmp49_;
	ValaDataType* _tmp50_;
	ValaTypeSymbol* _tmp51_;
	ValaTypeSymbol* _tmp52_;
	ValaSemanticAnalyzer* _tmp53_;
	ValaSemanticAnalyzer* _tmp54_;
	ValaDataType* _tmp55_;
	ValaTypeSymbol* _tmp56_;
	ValaTypeSymbol* _tmp57_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_symbol_get_external_package ((ValaSymbol*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = vala_code_context_get_entry_point_name (context);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = vala_symbol_get_name ((ValaSymbol*) self);
		_tmp6_ = _tmp5_;
		if (_tmp6_ == NULL) {
			_tmp4_ = TRUE;
		} else {
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			_tmp7_ = vala_symbol_get_name ((ValaSymbol*) self);
			_tmp8_ = _tmp7_;
			_tmp4_ = g_strcmp0 (_tmp8_, "main") != 0;
		}
		if (_tmp4_) {
			result = FALSE;
			return result;
		}
	} else {
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gboolean _tmp13_;
		_tmp9_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp10_ = _tmp9_;
		_tmp11_ = vala_code_context_get_entry_point_name (context);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strcmp0 (_tmp10_, _tmp12_) != 0;
		_g_free0 (_tmp10_);
		if (_tmp13_) {
			result = FALSE;
			return result;
		}
	}
	_tmp14_ = self->priv->_binding;
	if (_tmp14_ == VALA_MEMBER_BINDING_INSTANCE) {
		result = FALSE;
		return result;
	}
	_tmp15_ = vala_callable_get_return_type ((ValaCallable*) self);
	_tmp16_ = _tmp15_;
	if (VALA_IS_VOID_TYPE (_tmp16_)) {
	} else {
		ValaDataType* _tmp17_;
		ValaDataType* _tmp18_;
		ValaTypeSymbol* _tmp19_;
		ValaTypeSymbol* _tmp20_;
		ValaSemanticAnalyzer* _tmp21_;
		ValaSemanticAnalyzer* _tmp22_;
		ValaDataType* _tmp23_;
		ValaTypeSymbol* _tmp24_;
		ValaTypeSymbol* _tmp25_;
		_tmp17_ = vala_callable_get_return_type ((ValaCallable*) self);
		_tmp18_ = _tmp17_;
		_tmp19_ = vala_data_type_get_data_type (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = vala_code_context_get_analyzer (context);
		_tmp22_ = _tmp21_;
		_tmp23_ = _tmp22_->int_type;
		_tmp24_ = vala_data_type_get_data_type (_tmp23_);
		_tmp25_ = _tmp24_;
		if (_tmp20_ == _tmp25_) {
		} else {
			result = FALSE;
			return result;
		}
	}
	_tmp26_ = vala_callable_get_parameters ((ValaCallable*) self);
	params = _tmp26_;
	_tmp27_ = params;
	_tmp28_ = vala_collection_get_size ((ValaCollection*) _tmp27_);
	_tmp29_ = _tmp28_;
	if (_tmp29_ == 0) {
		result = TRUE;
		_vala_iterable_unref0 (params);
		return result;
	}
	_tmp30_ = params;
	_tmp31_ = vala_collection_get_size ((ValaCollection*) _tmp30_);
	_tmp32_ = _tmp31_;
	if (_tmp32_ > 1) {
		result = FALSE;
		_vala_iterable_unref0 (params);
		return result;
	}
	_tmp33_ = params;
	_tmp34_ = vala_iterable_iterator ((ValaIterable*) _tmp33_);
	params_it = _tmp34_;
	_tmp35_ = params_it;
	vala_iterator_next (_tmp35_);
	_tmp36_ = params_it;
	_tmp37_ = vala_iterator_get (_tmp36_);
	param = (ValaParameter*) _tmp37_;
	_tmp38_ = param;
	_tmp39_ = vala_parameter_get_direction (_tmp38_);
	_tmp40_ = _tmp39_;
	if (_tmp40_ == VALA_PARAMETER_DIRECTION_OUT) {
		result = FALSE;
		_vala_code_node_unref0 (param);
		_vala_iterator_unref0 (params_it);
		_vala_iterable_unref0 (params);
		return result;
	}
	_tmp41_ = param;
	_tmp42_ = vala_variable_get_variable_type ((ValaVariable*) _tmp41_);
	_tmp43_ = _tmp42_;
	if (!VALA_IS_ARRAY_TYPE (_tmp43_)) {
		result = FALSE;
		_vala_code_node_unref0 (param);
		_vala_iterator_unref0 (params_it);
		_vala_iterable_unref0 (params);
		return result;
	}
	_tmp44_ = param;
	_tmp45_ = vala_variable_get_variable_type ((ValaVariable*) _tmp44_);
	_tmp46_ = _tmp45_;
	_tmp47_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, VALA_TYPE_ARRAY_TYPE, ValaArrayType));
	array_type = _tmp47_;
	_tmp48_ = array_type;
	_tmp49_ = vala_array_type_get_element_type (_tmp48_);
	_tmp50_ = _tmp49_;
	_tmp51_ = vala_data_type_get_data_type (_tmp50_);
	_tmp52_ = _tmp51_;
	_tmp53_ = vala_code_context_get_analyzer (context);
	_tmp54_ = _tmp53_;
	_tmp55_ = _tmp54_->string_type;
	_tmp56_ = vala_data_type_get_data_type (_tmp55_);
	_tmp57_ = _tmp56_;
	if (_tmp52_ != _tmp57_) {
		result = FALSE;
		_vala_code_node_unref0 (array_type);
		_vala_code_node_unref0 (param);
		_vala_iterator_unref0 (params_it);
		_vala_iterable_unref0 (params);
		return result;
	}
	result = TRUE;
	_vala_code_node_unref0 (array_type);
	_vala_code_node_unref0 (param);
	_vala_iterator_unref0 (params_it);
	_vala_iterable_unref0 (params);
	return result;
}


gint
vala_method_get_required_arguments (ValaMethod* self)
{
	gint result = 0;
	gint n = 0;
	g_return_val_if_fail (self != NULL, 0);
	n = 0;
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _param_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _param_index = 0;
		_tmp0_ = self->priv->parameters;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_param_list = _tmp1_;
		_tmp2_ = _param_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_param_size = _tmp4_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaParameter* param = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			gboolean _tmp11_ = FALSE;
			ValaParameter* _tmp12_;
			ValaExpression* _tmp13_;
			ValaExpression* _tmp14_;
			gint _tmp18_;
			_tmp5_ = _param_index;
			_param_index = _tmp5_ + 1;
			_tmp6_ = _param_index;
			_tmp7_ = _param_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _param_list;
			_tmp9_ = _param_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			param = (ValaParameter*) _tmp10_;
			_tmp12_ = param;
			_tmp13_ = vala_variable_get_initializer ((ValaVariable*) _tmp12_);
			_tmp14_ = _tmp13_;
			if (_tmp14_ != NULL) {
				_tmp11_ = TRUE;
			} else {
				ValaParameter* _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
				_tmp15_ = param;
				_tmp16_ = vala_parameter_get_ellipsis (_tmp15_);
				_tmp17_ = _tmp16_;
				_tmp11_ = _tmp17_;
			}
			if (_tmp11_) {
				_vala_code_node_unref0 (param);
				break;
			}
			_tmp18_ = n;
			n = _tmp18_ + 1;
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	result = n;
	return result;
}


ValaMethod*
vala_method_get_end_method (ValaMethod* self)
{
	ValaMethod* result = NULL;
	gboolean _tmp0_;
	ValaMethod* _tmp1_;
	ValaMethod* _tmp39_;
	ValaMethod* _tmp40_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_coroutine;
	_vala_assert (_tmp0_, "this.coroutine");
	_tmp1_ = self->priv->end_method;
	if (_tmp1_ == NULL) {
		ValaDataType* _tmp2_;
		ValaDataType* _tmp3_;
		ValaSourceReference* _tmp4_;
		ValaSourceReference* _tmp5_;
		ValaMethod* _tmp6_;
		ValaMethod* _tmp7_;
		ValaMethod* _tmp8_;
		ValaMethod* _tmp9_;
		ValaScope* _tmp10_;
		ValaScope* _tmp11_;
		ValaMethod* _tmp38_;
		_tmp2_ = vala_callable_get_return_type ((ValaCallable*) self);
		_tmp3_ = _tmp2_;
		_tmp4_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp5_ = _tmp4_;
		_tmp6_ = vala_method_new ("end", _tmp3_, _tmp5_, NULL);
		_vala_code_node_unref0 (self->priv->end_method);
		self->priv->end_method = _tmp6_;
		_tmp7_ = self->priv->end_method;
		vala_symbol_set_access ((ValaSymbol*) _tmp7_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
		_tmp8_ = self->priv->end_method;
		vala_symbol_set_external ((ValaSymbol*) _tmp8_, TRUE);
		_tmp9_ = self->priv->end_method;
		_tmp10_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp11_ = _tmp10_;
		vala_symbol_set_owner ((ValaSymbol*) _tmp9_, _tmp11_);
		{
			ValaList* _param_list = NULL;
			ValaList* _tmp12_;
			gint _param_size = 0;
			ValaList* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _param_index = 0;
			_tmp12_ = vala_method_get_async_end_parameters (self);
			_param_list = _tmp12_;
			_tmp13_ = _param_list;
			_tmp14_ = vala_collection_get_size ((ValaCollection*) _tmp13_);
			_tmp15_ = _tmp14_;
			_param_size = _tmp15_;
			_param_index = -1;
			while (TRUE) {
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				ValaParameter* param = NULL;
				ValaList* _tmp19_;
				gint _tmp20_;
				gpointer _tmp21_;
				ValaMethod* _tmp22_;
				ValaParameter* _tmp23_;
				ValaParameter* _tmp24_;
				ValaParameter* _tmp25_;
				_tmp16_ = _param_index;
				_param_index = _tmp16_ + 1;
				_tmp17_ = _param_index;
				_tmp18_ = _param_size;
				if (!(_tmp17_ < _tmp18_)) {
					break;
				}
				_tmp19_ = _param_list;
				_tmp20_ = _param_index;
				_tmp21_ = vala_list_get (_tmp19_, _tmp20_);
				param = (ValaParameter*) _tmp21_;
				_tmp22_ = self->priv->end_method;
				_tmp23_ = param;
				_tmp24_ = vala_parameter_copy (_tmp23_);
				_tmp25_ = _tmp24_;
				vala_callable_add_parameter ((ValaCallable*) _tmp22_, _tmp25_);
				_vala_code_node_unref0 (_tmp25_);
				_vala_code_node_unref0 (param);
			}
			_vala_iterable_unref0 (_param_list);
		}
		{
			ValaList* _param_list = NULL;
			ValaList* _tmp26_;
			gint _param_size = 0;
			ValaList* _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
			gint _param_index = 0;
			_tmp26_ = vala_method_get_type_parameters (self);
			_param_list = _tmp26_;
			_tmp27_ = _param_list;
			_tmp28_ = vala_collection_get_size ((ValaCollection*) _tmp27_);
			_tmp29_ = _tmp28_;
			_param_size = _tmp29_;
			_param_index = -1;
			while (TRUE) {
				gint _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				ValaTypeParameter* param = NULL;
				ValaList* _tmp33_;
				gint _tmp34_;
				gpointer _tmp35_;
				ValaMethod* _tmp36_;
				ValaTypeParameter* _tmp37_;
				_tmp30_ = _param_index;
				_param_index = _tmp30_ + 1;
				_tmp31_ = _param_index;
				_tmp32_ = _param_size;
				if (!(_tmp31_ < _tmp32_)) {
					break;
				}
				_tmp33_ = _param_list;
				_tmp34_ = _param_index;
				_tmp35_ = vala_list_get (_tmp33_, _tmp34_);
				param = (ValaTypeParameter*) _tmp35_;
				_tmp36_ = self->priv->end_method;
				_tmp37_ = param;
				vala_method_add_type_parameter (_tmp36_, _tmp37_);
				_vala_code_node_unref0 (param);
			}
			_vala_iterable_unref0 (_param_list);
		}
		_tmp38_ = self->priv->end_method;
		vala_code_node_copy_attribute_double ((ValaCodeNode*) _tmp38_, (ValaCodeNode*) self, "CCode", "async_result_pos");
	}
	_tmp39_ = self->priv->end_method;
	_tmp40_ = _vala_code_node_ref0 (_tmp39_);
	result = _tmp40_;
	return result;
}


ValaMethod*
vala_method_get_callback_method (ValaMethod* self)
{
	ValaMethod* result = NULL;
	gboolean _tmp0_;
	ValaMethod* _tmp1_;
	ValaMethod* _tmp24_;
	ValaMethod* _tmp25_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_coroutine;
	_vala_assert (_tmp0_, "this.coroutine");
	_tmp1_ = self->priv->callback_method;
	if (_tmp1_ == NULL) {
		ValaBooleanType* bool_type = NULL;
		ValaCodeContext* _tmp2_;
		ValaCodeContext* _tmp3_;
		ValaNamespace* _tmp4_;
		ValaNamespace* _tmp5_;
		ValaScope* _tmp6_;
		ValaScope* _tmp7_;
		ValaSymbol* _tmp8_;
		ValaStruct* _tmp9_;
		ValaBooleanType* _tmp10_;
		ValaBooleanType* _tmp11_;
		ValaBooleanType* _tmp12_;
		ValaBooleanType* _tmp13_;
		ValaSourceReference* _tmp14_;
		ValaSourceReference* _tmp15_;
		ValaMethod* _tmp16_;
		ValaMethod* _tmp17_;
		ValaMethod* _tmp18_;
		ValaMethod* _tmp19_;
		ValaMethod* _tmp20_;
		ValaScope* _tmp21_;
		ValaScope* _tmp22_;
		ValaMethod* _tmp23_;
		_tmp2_ = vala_code_context_get ();
		_tmp3_ = _tmp2_;
		_tmp4_ = vala_code_context_get_root (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = vala_symbol_get_scope ((ValaSymbol*) _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_scope_lookup (_tmp7_, "bool");
		_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, VALA_TYPE_STRUCT, ValaStruct);
		_tmp10_ = vala_boolean_type_new (_tmp9_);
		_tmp11_ = _tmp10_;
		_vala_code_node_unref0 (_tmp9_);
		_vala_code_context_unref0 (_tmp3_);
		bool_type = _tmp11_;
		_tmp12_ = bool_type;
		vala_data_type_set_value_owned ((ValaDataType*) _tmp12_, TRUE);
		_tmp13_ = bool_type;
		_tmp14_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp15_ = _tmp14_;
		_tmp16_ = vala_method_new ("callback", (ValaDataType*) _tmp13_, _tmp15_, NULL);
		_vala_code_node_unref0 (self->priv->callback_method);
		self->priv->callback_method = _tmp16_;
		_tmp17_ = self->priv->callback_method;
		vala_symbol_set_access ((ValaSymbol*) _tmp17_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
		_tmp18_ = self->priv->callback_method;
		vala_symbol_set_external ((ValaSymbol*) _tmp18_, TRUE);
		_tmp19_ = self->priv->callback_method;
		vala_method_set_binding (_tmp19_, VALA_MEMBER_BINDING_INSTANCE);
		_tmp20_ = self->priv->callback_method;
		_tmp21_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp22_ = _tmp21_;
		vala_symbol_set_owner ((ValaSymbol*) _tmp20_, _tmp22_);
		_tmp23_ = self->priv->callback_method;
		vala_method_set_is_async_callback (_tmp23_, TRUE);
		_vala_code_node_unref0 (bool_type);
	}
	_tmp24_ = self->priv->callback_method;
	_tmp25_ = _vala_code_node_ref0 (_tmp24_);
	result = _tmp25_;
	return result;
}


ValaList*
vala_method_get_async_begin_parameters (ValaMethod* self)
{
	ValaList* result = NULL;
	gboolean _tmp0_;
	ValaSymbol* glib_ns = NULL;
	ValaCodeContext* _tmp1_;
	ValaCodeContext* _tmp2_;
	ValaNamespace* _tmp3_;
	ValaNamespace* _tmp4_;
	ValaScope* _tmp5_;
	ValaScope* _tmp6_;
	ValaSymbol* _tmp7_;
	ValaSymbol* _tmp8_;
	ValaArrayList* params = NULL;
	GEqualFunc _tmp9_;
	ValaArrayList* _tmp10_;
	ValaParameter* ellipsis = NULL;
	ValaDelegateType* callback_type = NULL;
	ValaSymbol* _tmp32_;
	ValaScope* _tmp33_;
	ValaScope* _tmp34_;
	ValaSymbol* _tmp35_;
	ValaDelegate* _tmp36_;
	ValaDelegateType* _tmp37_;
	ValaDelegateType* _tmp38_;
	ValaDelegateType* _tmp39_;
	ValaDelegateType* _tmp40_;
	ValaDelegateType* _tmp41_;
	ValaParameter* callback_param = NULL;
	ValaDelegateType* _tmp42_;
	ValaParameter* _tmp43_;
	ValaParameter* _tmp44_;
	ValaSourceReference* _tmp45_;
	ValaSourceReference* _tmp46_;
	ValaNullLiteral* _tmp47_;
	ValaNullLiteral* _tmp48_;
	ValaParameter* _tmp49_;
	ValaExpression* _tmp50_;
	ValaExpression* _tmp51_;
	ValaDelegateType* _tmp52_;
	ValaDataType* _tmp53_;
	ValaDataType* _tmp54_;
	ValaParameter* _tmp55_;
	ValaParameter* _tmp56_;
	ValaArrayList* _tmp57_;
	ValaParameter* _tmp58_;
	ValaParameter* _tmp59_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_coroutine;
	_vala_assert (_tmp0_, "this.coroutine");
	_tmp1_ = vala_code_context_get ();
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_code_context_get_root (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = vala_symbol_get_scope ((ValaSymbol*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = vala_scope_lookup (_tmp6_, "GLib");
	_tmp8_ = _tmp7_;
	_vala_code_context_unref0 (_tmp2_);
	glib_ns = _tmp8_;
	_tmp9_ = g_direct_equal;
	_tmp10_ = vala_array_list_new (VALA_TYPE_PARAMETER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp9_);
	params = _tmp10_;
	ellipsis = NULL;
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp11_;
		ValaList* _tmp12_;
		gint _param_size = 0;
		ValaList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _param_index = 0;
		_tmp11_ = self->priv->parameters;
		_tmp12_ = _vala_iterable_ref0 (_tmp11_);
		_param_list = _tmp12_;
		_tmp13_ = _param_list;
		_tmp14_ = vala_collection_get_size ((ValaCollection*) _tmp13_);
		_tmp15_ = _tmp14_;
		_param_size = _tmp15_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			ValaParameter* param = NULL;
			ValaList* _tmp19_;
			gint _tmp20_;
			gpointer _tmp21_;
			ValaParameter* _tmp22_;
			gboolean _tmp23_;
			gboolean _tmp24_;
			_tmp16_ = _param_index;
			_param_index = _tmp16_ + 1;
			_tmp17_ = _param_index;
			_tmp18_ = _param_size;
			if (!(_tmp17_ < _tmp18_)) {
				break;
			}
			_tmp19_ = _param_list;
			_tmp20_ = _param_index;
			_tmp21_ = vala_list_get (_tmp19_, _tmp20_);
			param = (ValaParameter*) _tmp21_;
			_tmp22_ = param;
			_tmp23_ = vala_parameter_get_ellipsis (_tmp22_);
			_tmp24_ = _tmp23_;
			if (_tmp24_) {
				ValaParameter* _tmp25_;
				ValaParameter* _tmp26_;
				_tmp25_ = param;
				_tmp26_ = _vala_code_node_ref0 (_tmp25_);
				_vala_code_node_unref0 (ellipsis);
				ellipsis = _tmp26_;
			} else {
				ValaParameter* _tmp27_;
				ValaParameterDirection _tmp28_;
				ValaParameterDirection _tmp29_;
				_tmp27_ = param;
				_tmp28_ = vala_parameter_get_direction (_tmp27_);
				_tmp29_ = _tmp28_;
				if (_tmp29_ == VALA_PARAMETER_DIRECTION_IN) {
					ValaArrayList* _tmp30_;
					ValaParameter* _tmp31_;
					_tmp30_ = params;
					_tmp31_ = param;
					vala_collection_add ((ValaCollection*) _tmp30_, _tmp31_);
				}
			}
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	_tmp32_ = glib_ns;
	_tmp33_ = vala_symbol_get_scope (_tmp32_);
	_tmp34_ = _tmp33_;
	_tmp35_ = vala_scope_lookup (_tmp34_, "AsyncReadyCallback");
	_tmp36_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, VALA_TYPE_DELEGATE, ValaDelegate);
	_tmp37_ = vala_delegate_type_new (_tmp36_);
	_tmp38_ = _tmp37_;
	_vala_code_node_unref0 (_tmp36_);
	callback_type = _tmp38_;
	_tmp39_ = callback_type;
	vala_data_type_set_nullable ((ValaDataType*) _tmp39_, TRUE);
	_tmp40_ = callback_type;
	vala_data_type_set_value_owned ((ValaDataType*) _tmp40_, TRUE);
	_tmp41_ = callback_type;
	vala_delegate_type_set_is_called_once (_tmp41_, TRUE);
	_tmp42_ = callback_type;
	_tmp43_ = vala_parameter_new ("_callback_", (ValaDataType*) _tmp42_, NULL);
	callback_param = _tmp43_;
	_tmp44_ = callback_param;
	_tmp45_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
	_tmp46_ = _tmp45_;
	_tmp47_ = vala_null_literal_new (_tmp46_);
	_tmp48_ = _tmp47_;
	vala_variable_set_initializer ((ValaVariable*) _tmp44_, (ValaExpression*) _tmp48_);
	_vala_code_node_unref0 (_tmp48_);
	_tmp49_ = callback_param;
	_tmp50_ = vala_variable_get_initializer ((ValaVariable*) _tmp49_);
	_tmp51_ = _tmp50_;
	_tmp52_ = callback_type;
	_tmp53_ = vala_data_type_copy ((ValaDataType*) _tmp52_);
	_tmp54_ = _tmp53_;
	vala_expression_set_target_type (_tmp51_, _tmp54_);
	_vala_code_node_unref0 (_tmp54_);
	_tmp55_ = callback_param;
	vala_code_node_set_attribute_double ((ValaCodeNode*) _tmp55_, "CCode", "pos", (gdouble) -1, NULL);
	_tmp56_ = callback_param;
	vala_code_node_set_attribute_double ((ValaCodeNode*) _tmp56_, "CCode", "delegate_target_pos", -0.9, NULL);
	_tmp57_ = params;
	_tmp58_ = callback_param;
	vala_collection_add ((ValaCollection*) _tmp57_, _tmp58_);
	_tmp59_ = ellipsis;
	if (_tmp59_ != NULL) {
		ValaArrayList* _tmp60_;
		ValaParameter* _tmp61_;
		_tmp60_ = params;
		_tmp61_ = ellipsis;
		vala_collection_add ((ValaCollection*) _tmp60_, _tmp61_);
	}
	result = (ValaList*) params;
	_vala_code_node_unref0 (callback_param);
	_vala_code_node_unref0 (callback_type);
	_vala_code_node_unref0 (ellipsis);
	_vala_code_node_unref0 (glib_ns);
	return result;
}


ValaList*
vala_method_get_async_end_parameters (ValaMethod* self)
{
	ValaList* result = NULL;
	gboolean _tmp0_;
	ValaArrayList* params = NULL;
	GEqualFunc _tmp1_;
	ValaArrayList* _tmp2_;
	ValaSymbol* glib_ns = NULL;
	ValaCodeContext* _tmp3_;
	ValaCodeContext* _tmp4_;
	ValaNamespace* _tmp5_;
	ValaNamespace* _tmp6_;
	ValaScope* _tmp7_;
	ValaScope* _tmp8_;
	ValaSymbol* _tmp9_;
	ValaSymbol* _tmp10_;
	ValaObjectType* result_type = NULL;
	ValaSymbol* _tmp11_;
	ValaScope* _tmp12_;
	ValaScope* _tmp13_;
	ValaSymbol* _tmp14_;
	ValaObjectTypeSymbol* _tmp15_;
	ValaObjectType* _tmp16_;
	ValaObjectType* _tmp17_;
	ValaParameter* result_param = NULL;
	ValaObjectType* _tmp18_;
	ValaParameter* _tmp19_;
	ValaParameter* _tmp20_;
	ValaArrayList* _tmp21_;
	ValaParameter* _tmp22_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_coroutine;
	_vala_assert (_tmp0_, "this.coroutine");
	_tmp1_ = g_direct_equal;
	_tmp2_ = vala_array_list_new (VALA_TYPE_PARAMETER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp1_);
	params = _tmp2_;
	_tmp3_ = vala_code_context_get ();
	_tmp4_ = _tmp3_;
	_tmp5_ = vala_code_context_get_root (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = vala_symbol_get_scope ((ValaSymbol*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = vala_scope_lookup (_tmp8_, "GLib");
	_tmp10_ = _tmp9_;
	_vala_code_context_unref0 (_tmp4_);
	glib_ns = _tmp10_;
	_tmp11_ = glib_ns;
	_tmp12_ = vala_symbol_get_scope (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = vala_scope_lookup (_tmp13_, "AsyncResult");
	_tmp15_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol);
	_tmp16_ = vala_object_type_new (_tmp15_);
	_tmp17_ = _tmp16_;
	_vala_code_node_unref0 (_tmp15_);
	result_type = _tmp17_;
	_tmp18_ = result_type;
	_tmp19_ = vala_parameter_new ("_res_", (ValaDataType*) _tmp18_, NULL);
	result_param = _tmp19_;
	_tmp20_ = result_param;
	vala_code_node_set_attribute_double ((ValaCodeNode*) _tmp20_, "CCode", "pos", vala_code_node_get_attribute_double ((ValaCodeNode*) self, "CCode", "async_result_pos", 0.1), NULL);
	_tmp21_ = params;
	_tmp22_ = result_param;
	vala_collection_add ((ValaCollection*) _tmp21_, _tmp22_);
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp23_;
		ValaList* _tmp24_;
		gint _param_size = 0;
		ValaList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _param_index = 0;
		_tmp23_ = self->priv->parameters;
		_tmp24_ = _vala_iterable_ref0 (_tmp23_);
		_param_list = _tmp24_;
		_tmp25_ = _param_list;
		_tmp26_ = vala_collection_get_size ((ValaCollection*) _tmp25_);
		_tmp27_ = _tmp26_;
		_param_size = _tmp27_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			ValaParameter* param = NULL;
			ValaList* _tmp31_;
			gint _tmp32_;
			gpointer _tmp33_;
			ValaParameter* _tmp34_;
			ValaParameterDirection _tmp35_;
			ValaParameterDirection _tmp36_;
			_tmp28_ = _param_index;
			_param_index = _tmp28_ + 1;
			_tmp29_ = _param_index;
			_tmp30_ = _param_size;
			if (!(_tmp29_ < _tmp30_)) {
				break;
			}
			_tmp31_ = _param_list;
			_tmp32_ = _param_index;
			_tmp33_ = vala_list_get (_tmp31_, _tmp32_);
			param = (ValaParameter*) _tmp33_;
			_tmp34_ = param;
			_tmp35_ = vala_parameter_get_direction (_tmp34_);
			_tmp36_ = _tmp35_;
			if (_tmp36_ == VALA_PARAMETER_DIRECTION_OUT) {
				ValaArrayList* _tmp37_;
				ValaParameter* _tmp38_;
				_tmp37_ = params;
				_tmp38_ = param;
				vala_collection_add ((ValaCollection*) _tmp37_, _tmp38_);
			}
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	result = (ValaList*) params;
	_vala_code_node_unref0 (result_param);
	_vala_code_node_unref0 (result_type);
	_vala_code_node_unref0 (glib_ns);
	return result;
}


void
vala_method_add_captured_variable (ValaMethod* self,
                                   ValaLocalVariable* local)
{
	gboolean _tmp0_;
	ValaList* _tmp1_;
	ValaList* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (local != NULL);
	_tmp0_ = self->priv->_closure;
	_vala_assert (_tmp0_, "this.closure");
	_tmp1_ = self->priv->captured_variables;
	if (_tmp1_ == NULL) {
		GEqualFunc _tmp2_;
		ValaArrayList* _tmp3_;
		_tmp2_ = g_direct_equal;
		_tmp3_ = vala_array_list_new (VALA_TYPE_LOCAL_VARIABLE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp2_);
		_vala_iterable_unref0 (self->priv->captured_variables);
		self->priv->captured_variables = (ValaList*) _tmp3_;
	}
	_tmp4_ = self->priv->captured_variables;
	vala_collection_add ((ValaCollection*) _tmp4_, local);
}


void
vala_method_get_captured_variables (ValaMethod* self,
                                    ValaCollection* variables)
{
	ValaList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (variables != NULL);
	_tmp0_ = self->priv->captured_variables;
	if (_tmp0_ != NULL) {
		{
			ValaList* _local_list = NULL;
			ValaList* _tmp1_;
			ValaList* _tmp2_;
			gint _local_size = 0;
			ValaList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _local_index = 0;
			_tmp1_ = self->priv->captured_variables;
			_tmp2_ = _vala_iterable_ref0 (_tmp1_);
			_local_list = _tmp2_;
			_tmp3_ = _local_list;
			_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
			_tmp5_ = _tmp4_;
			_local_size = _tmp5_;
			_local_index = -1;
			while (TRUE) {
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				ValaLocalVariable* local = NULL;
				ValaList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_;
				ValaLocalVariable* _tmp12_;
				_tmp6_ = _local_index;
				_local_index = _tmp6_ + 1;
				_tmp7_ = _local_index;
				_tmp8_ = _local_size;
				if (!(_tmp7_ < _tmp8_)) {
					break;
				}
				_tmp9_ = _local_list;
				_tmp10_ = _local_index;
				_tmp11_ = vala_list_get (_tmp9_, _tmp10_);
				local = (ValaLocalVariable*) _tmp11_;
				_tmp12_ = local;
				vala_collection_add (variables, _tmp12_);
				_vala_code_node_unref0 (local);
			}
			_vala_iterable_unref0 (_local_list);
		}
	}
}


static void
vala_method_real_get_defined_variables (ValaCodeNode* base,
                                        ValaCollection* collection)
{
	ValaMethod * self;
	gboolean _tmp0_;
	self = (ValaMethod*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = self->priv->_closure;
	if (_tmp0_) {
		vala_method_get_captured_variables (self, G_TYPE_CHECK_INSTANCE_CAST (collection, VALA_TYPE_COLLECTION, ValaCollection));
	}
}


gint
vala_method_get_format_arg_index (ValaMethod* self)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				ValaList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				ValaList* _tmp6_;
				gint _tmp7_;
				gpointer _tmp8_;
				ValaParameter* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->parameters;
				_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->parameters;
				_tmp7_ = i;
				_tmp8_ = vala_list_get (_tmp6_, _tmp7_);
				_tmp9_ = (ValaParameter*) _tmp8_;
				_tmp10_ = vala_parameter_get_format_arg (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = _tmp11_;
				_vala_code_node_unref0 (_tmp9_);
				if (_tmp12_) {
					result = i;
					return result;
				}
			}
		}
	}
	result = -1;
	return result;
}


gboolean
vala_method_has_error_type_parameter (ValaMethod* self)
{
	gboolean result = FALSE;
	ValaList* _tmp0_;
	ValaList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	ValaMethod* _tmp7_;
	ValaMethod* _tmp8_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	ValaMethod* _tmp15_;
	ValaMethod* _tmp16_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = vala_code_node_get_error_types ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ > 0;
	_vala_iterable_unref0 (_tmp1_);
	if (_tmp4_) {
		result = TRUE;
		return result;
	}
	_tmp7_ = vala_method_get_base_method (self);
	_tmp8_ = _tmp7_;
	if (_tmp8_ != NULL) {
		ValaMethod* _tmp9_;
		ValaMethod* _tmp10_;
		_tmp9_ = vala_method_get_base_method (self);
		_tmp10_ = _tmp9_;
		_tmp6_ = _tmp10_ != self;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		ValaMethod* _tmp11_;
		ValaMethod* _tmp12_;
		_tmp11_ = vala_method_get_base_method (self);
		_tmp12_ = _tmp11_;
		_tmp5_ = vala_method_has_error_type_parameter (_tmp12_);
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		result = TRUE;
		return result;
	}
	_tmp15_ = vala_method_get_base_interface_method (self);
	_tmp16_ = _tmp15_;
	if (_tmp16_ != NULL) {
		ValaMethod* _tmp17_;
		ValaMethod* _tmp18_;
		_tmp17_ = vala_method_get_base_interface_method (self);
		_tmp18_ = _tmp17_;
		_tmp14_ = _tmp18_ != self;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		ValaMethod* _tmp19_;
		ValaMethod* _tmp20_;
		_tmp19_ = vala_method_get_base_interface_method (self);
		_tmp20_ = _tmp19_;
		_tmp13_ = vala_method_has_error_type_parameter (_tmp20_);
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static ValaDataType*
vala_method_real_get_return_type (ValaCallable* base)
{
	ValaDataType* result;
	ValaMethod* self;
	ValaDataType* _tmp0_;
	self = (ValaMethod*) base;
	_tmp0_ = self->priv->_return_type;
	result = _tmp0_;
	return result;
}


static void
vala_method_real_set_return_type (ValaCallable* base,
                                  ValaDataType* value)
{
	ValaMethod* self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	self = (ValaMethod*) base;
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_return_type);
	self->priv->_return_type = _tmp0_;
	_tmp1_ = self->priv->_return_type;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
}


static gboolean
vala_method_real_get_has_result (ValaSubroutine* base)
{
	gboolean result;
	ValaMethod* self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	self = (ValaMethod*) base;
	_tmp0_ = vala_callable_get_return_type ((ValaCallable*) self);
	_tmp1_ = _tmp0_;
	result = !VALA_IS_VOID_TYPE (_tmp1_);
	return result;
}


ValaMemberBinding
vala_method_get_binding (ValaMethod* self)
{
	ValaMemberBinding result;
	ValaMemberBinding _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_binding;
	result = _tmp0_;
	return result;
}


void
vala_method_set_binding (ValaMethod* self,
                         ValaMemberBinding value)
{
	g_return_if_fail (self != NULL);
	self->priv->_binding = value;
}


gboolean
vala_method_get_is_abstract (ValaMethod* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_abstract;
	result = _tmp0_;
	return result;
}


void
vala_method_set_is_abstract (ValaMethod* self,
                             gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_abstract = value;
}


gboolean
vala_method_get_is_virtual (ValaMethod* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_virtual;
	result = _tmp0_;
	return result;
}


void
vala_method_set_is_virtual (ValaMethod* self,
                            gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_virtual = value;
}


gboolean
vala_method_get_overrides (ValaMethod* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_overrides;
	result = _tmp0_;
	return result;
}


void
vala_method_set_overrides (ValaMethod* self,
                           gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_overrides = value;
}


gboolean
vala_method_get_is_inline (ValaMethod* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_inline;
	result = _tmp0_;
	return result;
}


void
vala_method_set_is_inline (ValaMethod* self,
                           gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_inline = value;
}


gboolean
vala_method_get_returns_floating_reference (ValaMethod* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = vala_code_node_get_attribute_bool ((ValaCodeNode*) self, "CCode", "returns_floating_reference", FALSE);
	return result;
}


void
vala_method_set_returns_floating_reference (ValaMethod* self,
                                            gboolean value)
{
	g_return_if_fail (self != NULL);
	vala_code_node_set_attribute_bool ((ValaCodeNode*) self, "CCode", "returns_floating_reference", value, NULL);
}


gboolean
vala_method_get_returns_modified_pointer (ValaMethod* self)
{
	gboolean result;
	ValaAttribute* _tmp0_;
	ValaAttribute* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "ReturnsModifiedPointer");
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_ != NULL;
	_vala_code_node_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}


void
vala_method_set_returns_modified_pointer (ValaMethod* self,
                                          gboolean value)
{
	g_return_if_fail (self != NULL);
	vala_code_node_set_attribute ((ValaCodeNode*) self, "ReturnsModifiedPointer", value, NULL);
}


ValaMethod*
vala_method_get_base_method (ValaMethod* self)
{
	ValaMethod* result;
	ValaMethod* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	vala_method_find_base_methods (self);
	_tmp0_ = self->priv->_base_method;
	result = _tmp0_;
	return result;
}


ValaMethod*
vala_method_get_base_interface_method (ValaMethod* self)
{
	ValaMethod* result;
	ValaMethod* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	vala_method_find_base_methods (self);
	_tmp0_ = self->priv->_base_interface_method;
	result = _tmp0_;
	return result;
}


ValaDataType*
vala_method_get_base_interface_type (ValaMethod* self)
{
	ValaDataType* result;
	ValaDataType* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_base_interface_type;
	result = _tmp0_;
	return result;
}


void
vala_method_set_base_interface_type (ValaMethod* self,
                                     ValaDataType* value)
{
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_base_interface_type);
	self->priv->_base_interface_type = _tmp0_;
	_tmp1_ = self->priv->_base_interface_type;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
}


gboolean
vala_method_get_entry_point (ValaMethod* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_entry_point;
	result = _tmp0_;
	return result;
}


static void
vala_method_set_entry_point (ValaMethod* self,
                             gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_entry_point = value;
}


ValaParameter*
vala_method_get_this_parameter (ValaMethod* self)
{
	ValaParameter* result;
	ValaParameter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_this_parameter;
	result = _tmp0_;
	return result;
}


void
vala_method_set_this_parameter (ValaMethod* self,
                                ValaParameter* value)
{
	ValaParameter* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_this_parameter);
	self->priv->_this_parameter = _tmp0_;
}


gboolean
vala_method_get_printf_format (ValaMethod* self)
{
	gboolean result;
	ValaAttribute* _tmp0_;
	ValaAttribute* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "PrintfFormat");
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_ != NULL;
	_vala_code_node_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}


void
vala_method_set_printf_format (ValaMethod* self,
                               gboolean value)
{
	g_return_if_fail (self != NULL);
	vala_code_node_set_attribute ((ValaCodeNode*) self, "PrintfFormat", value, NULL);
}


gboolean
vala_method_get_scanf_format (ValaMethod* self)
{
	gboolean result;
	ValaAttribute* _tmp0_;
	ValaAttribute* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "ScanfFormat");
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_ != NULL;
	_vala_code_node_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}


void
vala_method_set_scanf_format (ValaMethod* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	vala_code_node_set_attribute ((ValaCodeNode*) self, "ScanfFormat", value, NULL);
}


gboolean
vala_method_get_has_construct_function (ValaMethod* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = vala_code_node_get_attribute_bool ((ValaCodeNode*) self, "CCode", "has_construct_function", TRUE);
	return result;
}


void
vala_method_set_has_construct_function (ValaMethod* self,
                                        gboolean value)
{
	g_return_if_fail (self != NULL);
	vala_code_node_set_attribute_bool ((ValaCodeNode*) self, "CCode", "has_construct_function", value, NULL);
}


ValaSignal*
vala_method_get_signal_reference (ValaMethod* self)
{
	ValaSignal* result;
	ValaSignal* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_signal_reference;
	result = _tmp0_;
	return result;
}


void
vala_method_set_signal_reference (ValaMethod* self,
                                  ValaSignal* value)
{
	g_return_if_fail (self != NULL);
	self->priv->_signal_reference = value;
}


gboolean
vala_method_get_closure (ValaMethod* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_closure;
	result = _tmp0_;
	return result;
}


void
vala_method_set_closure (ValaMethod* self,
                         gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_closure = value;
}


gboolean
vala_method_get_coroutine (ValaMethod* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_coroutine;
	result = _tmp0_;
	return result;
}


void
vala_method_set_coroutine (ValaMethod* self,
                           gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_coroutine = value;
}


gboolean
vala_method_get_is_async_callback (ValaMethod* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_async_callback;
	result = _tmp0_;
	return result;
}


void
vala_method_set_is_async_callback (ValaMethod* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_async_callback = value;
}


static void
vala_method_class_init (ValaMethodClass * klass)
{
	vala_method_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_method_finalize;
	g_type_class_add_private (klass, sizeof (ValaMethodPrivate));
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_method_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_method_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_type = (void (*) (ValaCodeNode*, ValaDataType*, ValaDataType*)) vala_method_real_replace_type;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_method_real_check;
	((ValaCodeNodeClass *) klass)->get_defined_variables = (void (*) (ValaCodeNode*, ValaCollection*)) vala_method_real_get_defined_variables;
	VALA_SUBROUTINE_CLASS (klass)->get_has_result = vala_method_real_get_has_result;
}


static void
vala_method_vala_callable_interface_init (ValaCallableIface * iface)
{
	vala_method_vala_callable_parent_iface = g_type_interface_peek_parent (iface);
	iface->add_parameter = (void (*) (ValaCallable*, ValaParameter*)) vala_method_real_add_parameter;
	iface->get_parameters = (ValaList* (*) (ValaCallable*)) vala_method_real_get_parameters;
	iface->get_return_type = vala_method_real_get_return_type;
	iface->set_return_type = vala_method_real_set_return_type;
}


static void
vala_method_instance_init (ValaMethod * self)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	self->priv = VALA_METHOD_GET_PRIVATE (self);
	self->priv->_binding = VALA_MEMBER_BINDING_INSTANCE;
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_PARAMETER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	self->priv->parameters = (ValaList*) _tmp1_;
}


static void
vala_method_finalize (ValaCodeNode * obj)
{
	ValaMethod * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_METHOD, ValaMethod);
	_vala_iterable_unref0 (self->priv->type_parameters);
	_vala_code_node_unref0 (self->priv->_this_parameter);
	_vala_iterable_unref0 (self->priv->parameters);
	_vala_iterable_unref0 (self->priv->preconditions);
	_vala_iterable_unref0 (self->priv->postconditions);
	_vala_code_node_unref0 (self->priv->_return_type);
	_vala_code_node_unref0 (self->priv->_base_interface_type);
	_vala_code_node_unref0 (self->priv->callback_method);
	_vala_code_node_unref0 (self->priv->end_method);
	_vala_iterable_unref0 (self->priv->captured_variables);
	VALA_CODE_NODE_CLASS (vala_method_parent_class)->finalize (obj);
}


/**
 * Represents a type or namespace method.
 */
GType
vala_method_get_type (void)
{
	static volatile gsize vala_method_type_id__volatile = 0;
	if (g_once_init_enter (&vala_method_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaMethodClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_method_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaMethod), 0, (GInstanceInitFunc) vala_method_instance_init, NULL };
		static const GInterfaceInfo vala_callable_info = { (GInterfaceInitFunc) vala_method_vala_callable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType vala_method_type_id;
		vala_method_type_id = g_type_register_static (VALA_TYPE_SUBROUTINE, "ValaMethod", &g_define_type_info, 0);
		g_type_add_interface_static (vala_method_type_id, VALA_TYPE_CALLABLE, &vala_callable_info);
		g_once_init_leave (&vala_method_type_id__volatile, vala_method_type_id);
	}
	return vala_method_type_id__volatile;
}



